VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLST"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use

'Some of the algorithms from
'J. Meeus, "Astronomical Algorithms", 2nd Ed., William-Bell Inc., Richmond, VG, 1998, p. 87
Friend Function FromLST(udtTime As Mytime, blnValid As Boolean) As Double
    Dim cDMS As New clsDMS
    Dim dblT As Double
    Dim dblT0 As Double
'    Dim cSun As New clsSun
    Dim cHebrew As New clsHebrew
    
    blnValid = True
    'Julian centuries from 2000
    dblT = (Int(dblDate + 1721424.5 - 2451545)) / 36525 'Julian centuries at 0 UTC
    'Time at 0 UTC
    dblT0 = (6.697374558 + dblT * (2400.0513385167 + dblT * (0.000025862 - dblT * 0.00000000172))) / 24 + udtLocation.dblLongitude / 360 * 0.99726956633
    dblT0 = dblT0 - Int(dblT0)
    FromLST = cDMS.FromDMS(udtTime.udtDms) / 24 - dblT0
    If udtTime.blnSecondTime Then FromLST = FromLST + 1
    FromLST = (FromLST - Int(FromLST)) * 0.99726956633
    If udtTime.blnSecondTime Then FromLST = FromLST + 0.9972695663
    If FromLST > 1 And udtDate.enmDateType < Hebrew Then
        blnValid = False
    ElseIf udtDate.enmDateType >= Hebrew Then
        Call cHebrew.AdjustTime(Int(dblDate), FromLST, blnValid)
    End If
End Function
Friend Sub ToLST(dblFix As Double, udtTimeIn As Mytime)
    Dim cDMS As New clsDMS
    Dim dblT As Double
    Dim dblT0 As Double
    Dim dblTime2 As Double
    
    udtTimeIn.bln24Hr = True
    udtTimeIn.enmTimeType = lst
    dblT = (Int(dblFix + 1721424.5 - 2451545)) / 36525
    dblT0 = (6.697374558 + dblT * (2400.0513385167 + dblT * (0.000025862 - dblT * 0.00000000172))) / 24 + udtLocation.dblLongitude / 360 * 0.99726956633
    dblT0 = dblT0 - Int(dblT0)
    udtTimeIn.blnSecondTime = dblTime / 0.99726956633 > 1 And dblTime < 1
    dblTime2 = dblTime / 0.99726956633 + dblT0
    dblTime2 = dblTime2 - Int(dblTime2)
    Call cDMS.ToDMS(dblTime2 * 24, udtTimeIn.udtDms)
End Sub
Friend Function StartOfDay(dblDate As Double, udtTime As Mytime, udtLoc As Location)
    StartOfDay = -udtLoc.dblLongitude / 360
End Function
Friend Function FixToLST(dblFix As Double, dblTD As Boolean) As Double 'In degrees
'dblFix is fixed radix in UTC or TD to LST in degrees
    Dim cGMST As New clsGMST

    FixToLST = FracCirc(cGMST.FixToGMST(dblFix, dblTD) + udtLocation.dblLongitude)
End Function


