VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPlanet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use
'Some of the algorithms from
'J. Meeus, "Astronomical Algorithms", 2nd Ed., William-Bell Inc., Richmond, VG, 1998, p. 87

Const AU = 149597870 'Astronomical unit in km

Friend Sub ReadPlanet(strName As String, udtPars As VSOP)
    Dim intFactor As Integer
    Dim intComponent As Integer
    Dim strLine As String
    
    Open strName & ".txt" For Input Access Read As 1
    ReDim udtPars.L(0)
    ReDim udtPars.B(0)
    ReDim udtPars.R(0)
    strLine = frmMain.GetNextLine()
    While Left(strLine, 1) = "L"
        intFactor = Mid(strLine, 2, 1)
        ReDim Preserve udtPars.L(intFactor)
        intComponent = 1
        While Mid(strLine, 2, 1) = intFactor And Left(strLine, 1) = "L"
            If intComponent <> frmMain.GetNextLine() Then MsgBox ("Corrupted planet file.")
            ReDim Preserve udtPars.L(intFactor).A(1 To intComponent)
            ReDim Preserve udtPars.L(intFactor).B(1 To intComponent)
            ReDim Preserve udtPars.L(intFactor).C(1 To intComponent)
            udtPars.L(intFactor).A(intComponent) = frmMain.GetNextLine()
            udtPars.L(intFactor).B(intComponent) = frmMain.GetNextLine()
            udtPars.L(intFactor).C(intComponent) = frmMain.GetNextLine()
            intComponent = intComponent + 1
            strLine = frmMain.GetNextLine()
        Wend
        udtPars.L(intFactor).N = intComponent - 1
    Wend
    udtPars.NL = intFactor
    While Left(strLine, 1) = "B"
        intFactor = Mid(strLine, 2, 1)
        ReDim Preserve udtPars.B(intFactor)
        intComponent = 1
        While Mid(strLine, 2, 1) = intFactor And Left(strLine, 1) = "B"
            If intComponent <> frmMain.GetNextLine() Then MsgBox ("Corrupted planet file.")
            ReDim Preserve udtPars.B(intFactor).A(1 To intComponent)
            ReDim Preserve udtPars.B(intFactor).B(1 To intComponent)
            ReDim Preserve udtPars.B(intFactor).C(1 To intComponent)
            udtPars.B(intFactor).A(intComponent) = frmMain.GetNextLine()
            udtPars.B(intFactor).B(intComponent) = frmMain.GetNextLine()
            udtPars.B(intFactor).C(intComponent) = frmMain.GetNextLine()
            intComponent = intComponent + 1
            strLine = frmMain.GetNextLine()
        Wend
        udtPars.B(intFactor).N = intComponent - 1
    Wend
    udtPars.NB = intFactor
    While Left(strLine, 1) = "R"
        intFactor = Mid(strLine, 2, 1)
        ReDim Preserve udtPars.R(intFactor)
        intComponent = 1
        While Mid(strLine, 2, 1) = intFactor And Left(strLine, 1) = "R"
            If intComponent <> frmMain.GetNextLine() Then MsgBox ("Corrupted planet file.")
            ReDim Preserve udtPars.R(intFactor).A(1 To intComponent)
            ReDim Preserve udtPars.R(intFactor).B(1 To intComponent)
            ReDim Preserve udtPars.R(intFactor).C(1 To intComponent)
            udtPars.R(intFactor).A(intComponent) = frmMain.GetNextLine()
            udtPars.R(intFactor).B(intComponent) = frmMain.GetNextLine()
            udtPars.R(intFactor).C(intComponent) = frmMain.GetNextLine()
            intComponent = intComponent + 1
            strLine = frmMain.GetNextLine()
        Wend
        udtPars.R(intFactor).N = intComponent - 1
    Wend
    udtPars.NR = intFactor
    Close 1
End Sub
Friend Sub HelioPlanet(strPlanet As String, dblFix As Double, dblL, dblB, dblR)
    Select Case strPlanet
        Case "Mercury":
            If Not blnMercury Then
                Call ReadPlanet(strPlanet, udtMercury)
                blnMercury = True
            End If
            Call helioplanet2(udtMercury, dblFix, dblL, dblB, dblR)
        Case "Venus":
            If Not blnVenus Then
                Call ReadPlanet(strPlanet, udtVenus)
                blnVenus = True
            End If
            Call helioplanet2(udtVenus, dblFix, dblL, dblB, dblR)
        Case "Earth":
            If Not blnEarth Then
                Call ReadPlanet(strPlanet, udtEarth)
                blnEarth = True
            End If
            Call helioplanet2(udtEarth, dblFix, dblL, dblB, dblR)
        Case "Jupiter":
            If Not blnJupiter Then
                Call ReadPlanet(strPlanet, udtJupiter)
                blnJupiter = True
            End If
            Call helioplanet2(udtJupiter, dblFix, dblL, dblB, dblR)
        Case Else
            MsgBox ("Invalid planet name in helioplanet")
    End Select
End Sub
Friend Sub helioplanet2(udtPars As VSOP, dblFix As Double, dblL, dblB, dblR)
    Dim dblTau As Double
    Dim intI As Integer
    Dim intJ As Integer
    Dim cJDE As New clsJDE
    
    dblTau = (cJDE.fixed_jde(dblFix) - 2451545) / 365250
    dblL = 0
    For intI = udtPars.NL To 0 Step -1
        dblL = dblL * dblTau
        For intJ = 1 To udtPars.L(intI).N
            dblL = dblL + udtPars.L(intI).A(intJ) * Cos(FracRadCirc(udtPars.L(intI).B(intJ) + dblTau * udtPars.L(intI).C(intJ)))
        Next
    Next
    dblL = FracCirc(dblL / 100000000# * RADCON)
    dblB = 0
    For intI = udtPars.NB To 0 Step -1
        dblB = dblB * dblTau
        For intJ = 1 To udtPars.B(intI).N
            dblB = dblB + udtPars.B(intI).A(intJ) * Cos(FracRadCirc(udtPars.B(intI).B(intJ) + dblTau * udtPars.B(intI).C(intJ)))
        Next
    Next
    dblB = FracCirc(dblB / 100000000# * RADCON)
    If dblB >= 180 Then dblB = dblB - 360
    dblR = 0
    For intI = udtPars.NR To 0 Step -1
        dblR = dblR * dblTau
        For intJ = 1 To udtPars.R(intI).N
            dblR = dblR + udtPars.R(intI).A(intJ) * Cos(FracRadCirc(udtPars.R(intI).B(intJ) + dblTau * udtPars.R(intI).C(intJ)))
        Next
    Next
    dblR = dblR / 100000000# * 149597870
End Sub

Friend Sub Planet(strPlanet As String, dblFix As Double, udtPlanet As HBody)
    Dim dblL As Double
    Dim dblB As Double
    Dim dblR As Double
    Dim dblLS As Double
    Dim dblBS As Double
    Dim dblRS As Double
    Dim dblX As Double
    Dim dblY As Double
    Dim dblZ As Double
    Dim dblDelta As Double 'Light time
    Dim dblDiameter As Double
    Dim intI As Integer
    Dim cSun As New clsSun
    Dim udtSun As HBody
    
    Select Case strPlanet
        Case "Mercury":
            dblDiameter = 4880
        Case "Venus":
            dblDiameter = 12103.6
        Case "Jupiter":
            dblDiameter = 142984
        Case Else
            MsgBox ("Invalid planet name")
    End Select
    dblDelta = 0
    For intI = 0 To 2
        Call HelioPlanet(strPlanet, dblFix - dblDelta, dblL, dblB, dblR)
        Call HelioPlanet("Earth", dblFix, dblLS, dblBS, dblRS)
        Call cSun.TrueSun(dblFix - dblDelta, udtSun)
        dblX = dblR * cosD(dblB) * cosD(dblL) - dblRS * cosD(dblBS) * cosD(dblLS)
        dblY = dblR * cosD(dblB) * sinD(dblL) - dblRS * cosD(dblBS) * sinD(dblLS)
        dblZ = dblR * sinD(dblB) - dblRS * sinD(dblBS)
        dblDelta = Sqr(Square(dblX) + Square(dblY) + Square(dblZ)) * 3.86068915885E-11
    Next
    udtPlanet.EclLong = atn2D(dblY, dblX)
    udtPlanet.EclDecl = atn2D(dblZ, Sqr(Square(dblX) + Square(dblY)))
    If udtPlanet.EclDecl >= 180 Then udtPlanet.EclDecl = udtPlanet.EclDecl - 360
    udtPlanet.DistanceGeo = dblDelta / 3.86068915885E-11
    Call cSun.ConvCoords(udtPlanet, dblFix, udtWeatherNow)
    udtPlanet.ElongationGeo = sinD(udtPlanet.DeclGeo) * sinD(udtSun.DeclTopo) + cosD(udtPlanet.DeclGeo) * cosD(udtSun.DeclGeo) * cosD(udtPlanet.RAGeo - udtSun.RAGeo)
    If udtPlanet.ElongationGeo > 0.999995 Then
        udtPlanet.ElongationGeo = Sqr(Square(udtSun.RAGeo - udtPlanet.RATopo) * cosD((udtPlanet.DeclGeo + udtSun.DeclGeo) / 2) + Square(udtPlanet.DeclGeo - udtSun.DeclGeo))
    ElseIf udtPlanet.ElongationGeo <= -1 Then
        udtPlanet.ElongationGeo = 180
    Else
        udtPlanet.ElongationGeo = acosD(udtPlanet.ElongationGeo)
    End If
    udtPlanet.ElongationTopo = sinD(udtPlanet.DeclTopo) * sinD(udtSun.DeclTopo) + cosD(udtPlanet.DeclTopo) * cosD(udtSun.DeclTopo) * cosD(udtPlanet.RATopo - udtSun.RATopo)
    If udtPlanet.ElongationTopo > 0.999995 Then
        udtPlanet.ElongationTopo = Sqr(Square(udtSun.RATopo - udtPlanet.RATopo) * cosD((udtPlanet.DeclTopo + udtSun.DeclTopo) / 2) + Square(udtPlanet.DeclTopo - udtSun.DeclTopo))
    ElseIf udtPlanet.ElongationTopo <= -1 Then
        udtPlanet.ElongationTopo = 180
    Else
        udtPlanet.ElongationTopo = acosD(udtPlanet.ElongationTopo)
    End If
    udtPlanet.Radius = asinD(dblDiameter / 2 / udtPlanet.DistanceTopo)
    udtPlanet.Phase = (1 - Sqr(1 - Square(udtSun.DistanceTopo * sinD(udtPlanet.ElongationTopo)) / (Square(udtSun.DistanceTopo) + Square(udtPlanet.DistanceGeo) - 2 * udtSun.DistanceTopo * udtPlanet.DistanceTopo * cosD(udtPlanet.ElongationTopo)))) / 2
    udtPlanet.Phase = (1 - Sqr(1 - Square(udtSun.DistanceTopo * sinD(udtPlanet.ElongationTopo + (udtPlanet.Phase - 1) * udtPlanet.Radius / 2)) / (Square(udtSun.DistanceTopo) + Square(udtPlanet.DistanceGeo) - 2 * udtSun.DistanceTopo * udtPlanet.DistanceTopo * cosD(udtPlanet.ElongationTopo + (udtPlanet.Phase - 1) * udtPlanet.Radius / 2)))) / 2
    If udtPlanet.DistanceTopo > udtSun.DistanceTopo * cosD(udtPlanet.ElongationTopo) Then udtPlanet.Phase = 1 - udtPlanet.Phase
End Sub
Friend Function EclipticCoordinates(strPlanet As String) As String
    Dim udtPlanet As HBody
    Dim udtDms As DMS
    Dim cDMS As New clsDMS
    
    Call Planet(strPlanet, dblDate + dblTime, udtPlanet)
    Call cDMS.ToDMS(udtPlanet.EclLong, udtDms)
    EclipticCoordinates = strPlanet & "'s geocentric ecliptic coordinates" & vbCrLf & "Longitude " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.EclDecl, udtDms)
    EclipticCoordinates = EclipticCoordinates & "Declination "
    If Not udtDms.blnSign Then EclipticCoordinates = EclipticCoordinates & "-"
    EclipticCoordinates = EclipticCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """"
End Function
Friend Function EquatorialCoordinates(strPlanet As String) As String
    Dim udtPlanet As HBody
    Dim udtDms As DMS
    Dim cDMS As New clsDMS
    
    Call Planet(strPlanet, dblDate + dblTime, udtPlanet)
    Call cDMS.ToDMS(udtPlanet.RAGeo, udtDms)
    EquatorialCoordinates = strPlanet & "'s geocentric equatorial coordinates" & vbCrLf & "Right ascension " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.RAGeo / 15, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & "              = " & udtDms.intDegreesHours & "h" & udtDms.intMinutes & "m" & Int(udtDms.dblSeconds) & "s" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.DeclGeo, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & "Declination "
    If Not udtDms.blnSign Then EquatorialCoordinates = EquatorialCoordinates & "-"
    EquatorialCoordinates = EquatorialCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.RATopo, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & strPlanet & "'s topocentric equatorial coordinates" & vbCrLf & "Right ascension " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.RATopo / 15, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & "              = " & udtDms.intDegreesHours & "h" & udtDms.intMinutes & "m" & Int(udtDms.dblSeconds) & "s" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.DeclTopo, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & "Declination "
    If Not udtDms.blnSign Then EquatorialCoordinates = EquatorialCoordinates & "-"
    EquatorialCoordinates = EquatorialCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """"
End Function
Friend Function HorizonCoordinates(strPlanet As String) As String
    Dim udtPlanet As HBody
    Dim udtDms As DMS
    Dim cDMS As New clsDMS
    
    Call Planet(strPlanet, dblDate + dblTime, udtPlanet)
    Call cDMS.ToDMS(udtPlanet.AzGeo, udtDms)
    HorizonCoordinates = strPlanet & "'s geocentric horizon coordinates" & vbCrLf & "Azimuth " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.AltGeo, udtDms)
    HorizonCoordinates = HorizonCoordinates & "Altitude "
    If Not udtDms.blnSign Then HorizonCoordinates = HorizonCoordinates & "-"
    HorizonCoordinates = HorizonCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.AzTopo, udtDms)
    HorizonCoordinates = HorizonCoordinates & strPlanet & "'s topocentric horizon coordinates" & vbCrLf & "Azimuth " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.AltTopo, udtDms)
    HorizonCoordinates = HorizonCoordinates & "Altitude "
    If Not udtDms.blnSign Then HorizonCoordinates = HorizonCoordinates & "-"
    HorizonCoordinates = HorizonCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """" & vbCrLf
    If udtPlanet.AltRefr <> -90 Then
        Call cDMS.ToDMS(udtPlanet.AltRefr, udtDms)
        HorizonCoordinates = HorizonCoordinates & "After correction for refraction" & vbCrLf & "Altitude "
        If Not udtDms.blnSign Then HorizonCoordinates = HorizonCoordinates & "-"
        HorizonCoordinates = HorizonCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """"
    Else
        HorizonCoordinates = HorizonCoordinates & strPlanet & " is well below the horizon so refraction cannot be calculated."
    End If
End Function
Friend Function DistSize(strPlanet As String) As String
    Dim udtPlanet As HBody
    Dim udtDms As DMS
    Dim cDMS As New clsDMS
    
    Call Planet(strPlanet, dblDate + dblTime, udtPlanet)
    DistSize = strPlanet & "'s distance and size" & vbCrLf & "Geocentric distance " & Format(udtPlanet.DistanceGeo, "000000") & " km" & vbCrLf
    DistSize = DistSize & "Topocentric distance " & Format(udtPlanet.DistanceTopo, "000000") & " km" & vbCrLf
    Call cDMS.ToDMS(udtPlanet.Radius, udtDms)
    DistSize = DistSize & "Topocentric radius " & udtDms.intMinutes & "'" & Int(udtDms.dblSeconds) & """"
End Function
Friend Sub RiseSet(strPlanet As String, lngFix As Long, blnSet As Boolean, dblRiseSetTime As Double, blnApparent As Boolean, blnNeverRises As Boolean, blnNeverSets As Boolean, Optional dblAltitude As Double = 0, Optional blnSeaLevelHorizon As Boolean = False)
'Find Planetrise or Planetset for a particular day (lngFix as fixed radix)
    Dim cLST As New clsLST
    Dim dblTheta0 As Double
    Dim udtPlanet(3) As HBody
    Dim dblH0 As Double
    Dim dblH As Double
    Dim dblHH As Double
    Dim dblY(3) As Double
    Dim dblAlpha As Double
    Dim dblDelta As Double
    Dim cDeltaT As New clsDeltaT
    Dim dblDip As Double
    Dim udtWeatherNow As WeatherNow
    Dim dblMidday As Double
    Dim cSun As New clsSun
    
    Call cSun.Meridian(lngFix, True, dblMidday)
    'Find celestial longitude at meridian at mean solar midday
    dblTheta0 = cLST.FixToLST(lngFix + 0.5 - udtLocation.dblLongitude / 360, False)
    'Find the position of the Sun at mean solar midday and for the days before and after
    Call Planet(strPlanet, lngFix - 0.5 - udtLocation.dblLongitude / 360, udtPlanet(0))
    Call Planet(strPlanet, lngFix + 0.5 - udtLocation.dblLongitude / 360, udtPlanet(1))
    Call Planet(strPlanet, lngFix + 1.5 - udtLocation.dblLongitude / 360, udtPlanet(2))
    'Determine the average weather
    Call frmWeather.GetWeatherNow(lngFix + 0.5, 0, udtWeatherNow)
    'Find the altitude at Sunset
    If blnApparent Then
        dblDip = -udtPlanet(1).Radius - cSun.Refract(0, False, udtWeatherNow) + dblAltitude
        If blnSeaLevelHorizon Then dblDip = dblDip - cSun.SeaLevelHorizon(udtWeatherNow)
    Else
        dblDip = dblAltitude
    End If
    'The hour angle
    dblH0 = sinD(dblDip) - sinD(udtLocation.dblLatitude) * sinD(udtPlanet(1).DeclTopo) / cosD(udtLocation.dblLatitude) / cosD(udtPlanet(1).DeclTopo)
    'If there is no rising or setting then determine midnight or midday
    blnNeverRises = dblH0 > 1
    blnNeverSets = dblH0 < -1
    If dblH0 < -1 Then
        dblH0 = -1
    ElseIf dblH0 > 1 Then
        dblH0 = 1
    End If
    'First approximation
    If blnSet Then
        dblRiseSetTime = (udtPlanet(1).RATopo - dblTheta0 + acosD(dblH0) - udtLocation.dblLongitude) / 360 + 0.5
        While dblRiseSetTime < dblMidday - 0.25 - lngFix
            dblRiseSetTime = dblRiseSetTime + 1
        Wend
        While dblRiseSetTime >= dblMidday + 0.75 - lngFix
            dblRiseSetTime = dblRiseSetTime - 1
        Wend
    Else
        dblRiseSetTime = FracCirc(udtPlanet(1).RATopo - dblTheta0 - acosD(dblH0) - udtLocation.dblLongitude) / 360 + 0.5
        While dblRiseSetTime < dblMidday - 0.75 - lngFix
            dblRiseSetTime = dblRiseSetTime + 1
        Wend
        While dblRiseSetTime >= dblMidday + 0.25 - lngFix
            dblRiseSetTime = dblRiseSetTime - 1
        Wend
    End If
    dblY(0) = udtPlanet(0).RATopo
    dblY(1) = udtPlanet(1).RATopo
    dblY(2) = udtPlanet(2).RATopo
    dblAlpha = Interp(dblY, dblRiseSetTime + udtLocation.dblLongitude / 360 + 0.5, 3)
    dblY(0) = udtPlanet(0).DeclTopo
    dblY(1) = udtPlanet(1).DeclTopo
    dblY(2) = udtPlanet(2).DeclTopo
    dblDelta = Interp(dblY, dblRiseSetTime + udtLocation.dblLongitude / 360 + 0.5, 3)
    If Abs(dblH0) > 0.98 Then 'May exceed 1 after iteration so result may be meaningless
        Call frmWeather.GetWeatherNow(lngFix + 0.5, 0, udtWeatherNow)
        Call Planet(strPlanet, lngFix + dblRiseSetTime, udtPlanet(1))
        If blnApparent Then
            dblDip = -udtPlanet(1).Radius - cSun.Refract(0, False, udtWeatherNow) + dblAltitude
            If blnSeaLevelHorizon Then dblDip = dblDip - cSun.SeaLevelHorizon(udtWeatherNow)
        Else
            dblDip = dblAltitude
        End If
        dblH0 = sinD(dblDip) - sinD(udtLocation.dblLatitude) * sinD(dblDelta) / cosD(udtLocation.dblLatitude) / cosD(dblDelta)
        blnNeverRises = dblH0 > 1
        blnNeverSets = dblH0 < -1
        If dblH0 < -1 Then
            dblH0 = -1
        ElseIf dblH0 > 1 Then
            dblH0 = 1
        End If
        If blnSet Then
            dblRiseSetTime = (dblAlpha - dblTheta0 + acosD(dblH0)) / 360
            While dblRiseSetTime < dblMidday - 0.25 - lngFix
                dblRiseSetTime = dblRiseSetTime + 1
            Wend
            While dblRiseSetTime >= dblMidday + 0.75 - lngFix
                dblRiseSetTime = dblRiseSetTime - 1
            Wend
        Else
            dblRiseSetTime = FracCirc(dblAlpha - dblTheta0 - acosD(dblH0)) / 360
            While dblRiseSetTime < dblMidday - 0.75 - lngFix
                dblRiseSetTime = dblRiseSetTime + 1
            Wend
            While dblRiseSetTime >= dblMidday + 0.25 - lngFix
                dblRiseSetTime = dblRiseSetTime - 1
            Wend
        End If
    Else
'    Call TrueSun(Int(dblFix) + dblRiseSetTime, udtSun(0))
'    Debug.Print -dblDip, udtSun(0).AltTopo
        dblH = cLST.FixToLST(lngFix + dblRiseSetTime, False)
        dblHH = asinD(sinD(udtLocation.dblLatitude) * sinD(dblDelta) + cosD(udtLocation.dblLatitude) * cosD(dblDelta) * cosD(dblH - dblAlpha))
        dblRiseSetTime = dblRiseSetTime + (dblHH - dblDip) / 360 / cosD(dblDelta) / cosD(udtLocation.dblLatitude) / sinD(dblH - dblAlpha)
    End If
    dblRiseSetTime = dblRiseSetTime + lngFix
'    Call TrueSun(Int(dblFix) + dblRiseSetTime, udtSun(0))
'    Debug.Print -dblDip, udtSun(0).AltTopo
End Sub
Friend Function PlanetRise(strPlanet As String) As String
'Return sunrise for that day
    Dim dblRiseSetTime As Double
    Dim blnNeverSets As Boolean
    Dim blnNeverRises As Boolean
    Dim intDays As Integer
    Dim udtDms As DMS
    Dim lngFix As Long
    Dim cDMS As New clsDMS
    Dim cMoon As New clsMoon
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    Dim blnValid As Boolean
    Dim strOldDate As String
    
    strOldDate = ""
    blnValid = True
    lngFix = frmDate.ToLngDate(dblDate + dblTime)
    Call RiseSet(strPlanet, lngFix, False, dblRiseSetTime, False, blnNeverRises, blnNeverSets)
    If blnNeverSets Then
        PlanetRise = "No geometric " & strPlanet & " set" & vbCrLf & "Minimum altitude at "
    ElseIf blnNeverRises Then
        PlanetRise = "No geometric " & strPlanet & " rise" & vbCrLf & "Maximum altitude at "
    Else
        PlanetRise = "Geometric " & strPlanet & " rise "
    End If
    Call frmMain.ToDateTime(dblRiseSetTime, udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
    PlanetRise = PlanetRise & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate)
    If Not blnNeverSets Then
        Call RiseSet(strPlanet, lngFix, False, dblRiseSetTime, True, blnNeverRises, blnNeverSets)
        If blnNeverSets Then
            PlanetRise = PlanetRise & vbCrLf & "No apparent " & strPlanet & " set over flat horizon" & vbCrLf & "Minimum altitude at "
        ElseIf blnNeverRises Then
            PlanetRise = PlanetRise & vbCrLf & "No apparent " & strPlanet & " rise over flat horizon" & vbCrLf & "Maximum altitude at "
        Else
            PlanetRise = PlanetRise & vbCrLf & "Apparent " & strPlanet & " rise over flat horizon "
        End If
        Call frmMain.ToDateTime(dblRiseSetTime, udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
        PlanetRise = PlanetRise & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate)
        If Not blnNeverSets Then
            Call RiseSet(strPlanet, lngFix, False, dblRiseSetTime, True, blnNeverRises, blnNeverSets, 0, True)
            If blnNeverSets Then
                PlanetRise = PlanetRise & vbCrLf & "No apparent " & strPlanet & " set over sea level horizon" & vbCrLf & "Minimum altitude at "
            ElseIf blnNeverRises Then
                PlanetRise = PlanetRise & vbCrLf & "No apparent " & strPlanet & " rise over sea level horizon" & vbCrLf & "Maximum altitude at "
            Else
                PlanetRise = PlanetRise & vbCrLf & "Apparent " & strPlanet & " rise over sea level horizon "
            End If
            Call frmMain.ToDateTime(dblRiseSetTime, udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
            PlanetRise = PlanetRise & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate)
        End If
    End If
End Function
Friend Function PlanetSet(strPlanet As String) As String
'Return sunrise for that day
    Dim dblRiseSetTime As Double
    Dim blnNeverSets As Boolean
    Dim blnNeverRises As Boolean
    Dim intDays As Integer
    Dim udtDms As DMS
    Dim lngFix As Long
    Dim cDMS As New clsDMS
    Dim cMoon As New clsMoon
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    Dim blnValid As Boolean
    Dim strOldDate As String
    
    strOldDate = ""
    blnValid = True
    lngFix = frmDate.ToLngDate(dblDate + dblTime)
    Call RiseSet(strPlanet, lngFix, True, dblRiseSetTime, False, blnNeverRises, blnNeverSets)
    If blnNeverSets Then
        PlanetSet = "No geometric " & strPlanet & " set" & vbCrLf & "Minimum altitude at "
    ElseIf blnNeverRises Then
        PlanetSet = "No geometric " & strPlanet & " rise" & vbCrLf & "Maximum altitude at "
    Else
        PlanetSet = "Geometric " & strPlanet & " set "
    End If
    Call frmMain.ToDateTime(dblRiseSetTime, udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
    PlanetSet = PlanetSet & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate)
    If Not blnNeverSets Then
        Call RiseSet(strPlanet, lngFix, True, dblRiseSetTime, True, blnNeverRises, blnNeverSets)
        If blnNeverSets Then
            PlanetSet = PlanetSet & vbCrLf & "No apparent " & strPlanet & " set over flat horizon" & vbCrLf & "Minimum altitude at "
        ElseIf blnNeverRises Then
            PlanetSet = PlanetSet & vbCrLf & "No apparent " & strPlanet & " rise over flat horizon" & vbCrLf & "Maximum altitude at "
        Else
            PlanetSet = PlanetSet & vbCrLf & "Apparent " & strPlanet & " set over flat horizon "
        End If
        Call frmMain.ToDateTime(dblRiseSetTime, udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
        PlanetSet = PlanetSet & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate)
        If Not blnNeverSets Then
            Call RiseSet(strPlanet, lngFix, True, dblRiseSetTime, True, blnNeverRises, blnNeverSets, 0, True)
            If blnNeverSets Then
                PlanetSet = PlanetSet & vbCrLf & "No apparent " & strPlanet & " set over sea level horizon" & vbCrLf & "Minimum altitude at "
            ElseIf blnNeverRises Then
                PlanetSet = PlanetSet & vbCrLf & "No apparent " & strPlanet & " rise over sea level horizon" & vbCrLf & "Maximum altitude at "
            Else
                PlanetSet = PlanetSet & vbCrLf & "Apparent " & strPlanet & " set over sea level horizon "
            End If
            Call frmMain.ToDateTime(dblRiseSetTime, udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
            PlanetSet = PlanetSet & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate)
        End If
    End If
End Function
Friend Function Magnitude(strPlanet As String, udtPlanet As HBody) As Double
'Calculate the magnitude of a plnaet as seen from above the atmosphere
    Dim dblRD As Double
    Dim dblI As Double
    
    'Planet's phase in degrees
    dblI = acosD(2 * udtPlanet.Phase - 1)
    'Planet's distance from the Sun times distance to planet in AU^2
    dblRD = Abs(sinD(udtPlanet.ElongationTopo) * udtPlanet.DistanceTopo / sinD(180 - udtPlanet.ElongationTopo - dblI) * udtPlanet.DistanceTopo / AU / AU)
    Select Case strPlanet
        Case "Mercury":
            Magnitude = 1.16 + 5 * Log10(dblRD) + (dblI - 50) * (0.02838 + (dblI - 50) * 0.0001023)
        Case "Venus":
            Magnitude = -4# + 5 * Log10(dblRD) + dblI * (0.01322 + dblI * dblI * 0.0000004247)
        Case "Jupiter":
            Magnitude = -8.93 + 5 * Log10(dblRD)
        Case Else
            MsgBox ("Invalid planet or planet not implemented")
    End Select
End Function
Friend Function MagText(strPlanet As String) As String
    Dim udtPlanet As HBody
    
    Call Planet(strPlanet, dblDate + dblTime, udtPlanet)
    MagText = strPlanet & "'s magnitude above the atmosphere " & Format(Magnitude(strPlanet, udtPlanet), "###.00")
End Function

