VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSignedDMS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Friend Function FromSignedDMS(udtDMS As SignedDMS) As Double
    FromSignedDMS = udtDMS.udtDMS.intDegreesHours + udtDMS.udtDMS.intMinutes / 60 + udtDMS.udtDMS.dblSeconds / 3600
    If Not udtDMS.blnSign Then FromSignedDMS = -FromSignedDMS
End Function
Friend Sub ToSignedDMS(dblX As Double, udtDMS As SignedDMS)
    With udtDMS
        .udtDMS.intDegreesHours = Int(Abs(dblX))
        .udtDMS.intMinutes = Int((Abs(dblX) - .udtDMS.intDegreesHours) * 60)
        .udtDMS.dblSeconds = (Abs(dblX) - .udtDMS.intDegreesHours - .udtDMS.intMinutes / 60) * 3600
        .blnSign = (dblX >= 0)
    End With
End Sub
Friend Function ValidSignedDMS(udtDMS As SignedDMS) As Boolean
    Dim udtDMSCheck As SignedDMS
    Dim dblNoddle As Double
    
    If udtDMS.blnSign Then
        dblNoddle = DMSResolution
    Else
        dblNoddle = -DMSResolution
    End If
    Call ToSignedDMS(FromSignedDMS(udtDMS) + dblNoddle, udtDMSCheck)
    ValidSignedDMS = (udtDMS.blnSign = udtDMSCheck.blnSign And Abs(udtDMS.udtDMS.dblSeconds - udtDMSCheck.udtDMS.dblSeconds) < DMSResolution * 7200 And udtDMS.udtDMS.intDegreesHours = udtDMSCheck.udtDMS.intDegreesHours And udtDMS.udtDMS.intMinutes = udtDMSCheck.udtDMS.intMinutes)
End Function
Friend Function ValidSignedDMSText(txtDegHour As String, txtminute As String, txtsecond As String, blnSign As Boolean, intMax As Integer) As Boolean
    Dim udtDMS As SignedDMS
    
    ValidSignedDMSText = False
    If IsNumeric(txtDegHour) And IsNumeric(txtminute) And IsNumeric(txtsecond) Then 'Must be numeric
        If Abs(txtDegHour) < 32767 And Abs(txtminute) < 32767 Then 'Must be in integer range
            'Convert to DMS structure
            udtDMS.blnSign = blnSign
            udtDMS.udtDMS.dblSeconds = txtsecond
            udtDMS.udtDMS.intDegreesHours = txtDegHour
            udtDMS.udtDMS.intMinutes = txtminute
            If ValidSignedDMS(udtDMS) Then 'Check for validity
                'Check to see if in range
                ValidSignedDMSText = (Abs(FromSignedDMS(udtDMS)) <= intMax)
            End If
        End If
    End If
End Function
Friend Function FromSignedDMSText(txtDegHour As String, txtminute As String, txtsecond As String, blnSign As Boolean) As Double
    Dim udtDMS As SignedDMS
    
    udtDMS.blnSign = blnSign
    udtDMS.udtDMS.dblSeconds = txtsecond
    udtDMS.udtDMS.intDegreesHours = txtDegHour
    udtDMS.udtDMS.intMinutes = txtminute
    FromSignedDMSText = FromSignedDMS(udtDMS)
End Function

