VERSION 5.00
Begin VB.Form frmDate 
   Caption         =   "Date"
   ClientHeight    =   1905
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2880
   Icon            =   "frmDate.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1905
   ScaleWidth      =   2880
   StartUpPosition =   3  'Windows Default
   Begin VB.OptionButton optCE 
      Caption         =   "CE"
      Height          =   255
      Left            =   600
      TabIndex        =   13
      Top             =   1560
      Value           =   -1  'True
      Width           =   615
   End
   Begin VB.OptionButton optBCE 
      Caption         =   "BCE"
      Height          =   255
      Left            =   0
      TabIndex        =   12
      Top             =   1560
      Width           =   615
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   255
      Left            =   1200
      TabIndex        =   11
      Top             =   1560
      Width           =   732
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   255
      Left            =   2040
      TabIndex        =   10
      Top             =   1560
      Width           =   732
   End
   Begin VB.TextBox txtDayNo 
      Height          =   285
      Left            =   1080
      TabIndex        =   9
      Text            =   "20000"
      Top             =   360
      Width           =   1215
   End
   Begin VB.TextBox txtYear 
      Height          =   285
      Left            =   1080
      TabIndex        =   7
      Text            =   "2000"
      Top             =   1200
      Width           =   975
   End
   Begin VB.ComboBox cboMonth 
      Height          =   288
      Left            =   1080
      TabIndex        =   5
      Text            =   "January"
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox txtDate 
      Height          =   285
      Left            =   1080
      TabIndex        =   3
      Text            =   "1"
      Top             =   600
      Width           =   1215
   End
   Begin VB.ComboBox cboType 
      Height          =   315
      Left            =   1080
      TabIndex        =   1
      Text            =   "Gregorian"
      Top             =   0
      Width           =   1215
   End
   Begin VB.Label lblDayNo 
      Caption         =   "Day number"
      Height          =   255
      Left            =   0
      TabIndex        =   8
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label lblYear 
      Caption         =   "Year"
      Height          =   255
      Left            =   0
      TabIndex        =   6
      Top             =   1200
      Width           =   1095
   End
   Begin VB.Label lblMonth 
      Caption         =   "Month"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   840
      Width           =   1095
   End
   Begin VB.Label lblDate 
      Caption         =   "Date of month"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   600
      Width           =   1095
   End
   Begin VB.Label lblType 
      Caption         =   "Date Type"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   975
   End
End
Attribute VB_Name = "frmDate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use

Dim blnCancelled As Boolean

Friend Sub ToDate(lngFix As Long, enmDateType As DateType, udtDateOut As MyDate, blnValid As Boolean)
'Convert integer radix date to calendar (non-radix) date
    Dim cGregorian As New clsGregorian
    Dim cJulian As New clsJulian
    Dim cHebrew As New clsHebrew
    Dim cIslamic As New clsIslamic
    
    Select Case enmDateType
        'Calculate date at 0:00 UTC
        Case Gregorian:
            Call cGregorian.fixed_gregorian(lngFix, udtDateOut, blnValid)
        Case Julian:
            Call cJulian.fixed_julian(lngFix, udtDateOut, blnValid)
        Case Hebrew:
            Call cHebrew.fixed_hebrew(lngFix, udtDateOut, blnValid)
        Case Islamic:
            Call cIslamic.Fixed_Islamic(lngFix, udtDateOut, blnValid)
        Case Else:
            MsgBox ("Not designed for radix dates")
    End Select
End Sub

Private Sub Update()
    optCE = udtDate.blnCE
    optBCE = Not udtDate.blnCE
    txtDayNo = udtDate.dblDayNumber
    txtDate = udtDate.intDateOfMonth
    cboMonth.ListIndex = udtDate.intMonth - 1
    cboMonth.Text = MonthName(udtDate.intMonth, cboType.ListIndex)
    txtYear = udtDate.intYear
End Sub

Private Sub cboType_Click()
    Dim cGregorian As New clsGregorian
    Dim cHebrew As New clsHebrew
    Dim cIslamic As New clsIslamic
    Dim intI As Integer
    Dim intMyMonth As Integer
    
    intMyMonth = cboMonth.ListIndex + 1
    'Change the list of months according to the calendar
    Select Case cboType.ListIndex
        Case Hebrew
            cboMonth.Clear
            For intI = 1 To 13
                cboMonth.AddItem (cHebrew.MonthName(intI))
            Next
        Case Islamic
            cboMonth.Clear
            For intI = 1 To 12
                cboMonth.AddItem (cIslamic.MonthName(intI))
            Next
        Case Else
            cboMonth.Clear
            For intI = 1 To 12
                cboMonth.AddItem (cGregorian.MonthName(intI))
            Next
    End Select
    cboMonth.ListIndex = intMyMonth - 1
    If cboMonth.ListIndex >= cboMonth.ListCount Then cboMonth.ListIndex = cboMonth.ListCount - 1
    'Enable and disable the appropriate fields depending on whether it is a radix or calendar date
    If cboType.ListIndex = Fixed Or cboType.ListIndex = JD Or cboType.ListIndex = JDE Or cboType.ListIndex = mjd Then
        txtDayNo.Enabled = True
        txtDate.Enabled = False
        cboMonth.Enabled = False
        txtYear.Enabled = False
    Else
        txtDayNo.Enabled = False
        txtDate.Enabled = True
        cboMonth.Enabled = True
        txtYear.Enabled = True
    End If
    'Enable BCE/CE only if it is a Julian date
    If cboType.ListIndex = Julian Then
        optBCE.Enabled = True
        optCE.Enabled = True
    Else
        optBCE.Enabled = False
        optCE.Enabled = False
    End If
End Sub

Private Sub cmdCancel_Click()
    blnCancelled = True
    Unload Me
End Sub

Private Sub cmdOK_Click()
    Dim blnError As Boolean 'Indicates that the time cannot be valid
    Dim strError As String 'String describing the error
    Dim cGregorian As New clsGregorian
    Dim cJulian As New clsJulian
    Dim cHebrew As New clsHebrew
    Dim cIslamic As New clsIslamic
    
    blnError = False
    strError = "Date cannot be valid"
    If cboType.ListIndex = Fixed Or cboType.ListIndex = JD Or cboType.ListIndex = JDE Or cboType.ListIndex = mjd Then
        'Radix dates must be a number
        If Not IsNumeric(txtDayNo) Then
            strError = strError & vbCrLf & "Day number must be a number."
            blnError = True
        End If
    Else
        'Calendar date
        'Read year
        If Not IsNumeric(txtYear) Then
            strError = strError & vbCrLf & "Year must be a number."
            blnError = True
        ElseIf Abs(txtYear) > 32766 Then
            strError = strError & vbCrLf & "Date out of range."
            blnError = True
        ElseIf txtYear < 1 And cboType.ListIndex = Julian Then
            strError = strError & vbCrLf & "Only positive years are valid for Julian dates, use the BCE option."
            blnError = True
        End If
        'Read date of month
        If Not IsNumeric(txtDate) Then
            strError = strError & vbCrLf & "Date of month must be a number."
            blnError = True
        ElseIf txtDate < 1 Or txtDate > 31 Then
            strError = strError & vbCrLf & "Date of month must be between 0 and 31."
            blnError = True
        ElseIf txtDate = 31 And (cboType.ListIndex = Hebrew Or cboType.ListIndex = Islamic) Then
            strError = strError & vbCrLf & "Date of month must be between 0 and 30 for Hebrew and Islamic calendars."
            blnError = True
        ElseIf ((txtDate > 29 And cboMonth.ListIndex = 1) Or txtDate = 31 And (cboMonth.ListIndex = 3 Or cboMonth.ListIndex = 5 Or cboMonth.ListIndex = 8 Or cboMonth.ListIndex = 10)) And (cboType.ListIndex = Gregorian Or cboType.ListIndex = Julian) Or txtDate = 30 And (cboMonth.ListIndex = 1 Or cboMonth.ListIndex = 3 Or cboMonth.ListIndex = 5 Or cboMonth.ListIndex = 9 Or cboMonth.ListIndex = 12) And cboType.ListIndex = Hebrew Or txtDate = 30 And cboMonth.ListIndex Mod 2 = 1 And cboMonth.ListIndex < 11 And cboType.ListIndex = Islamic Then
            strError = strError & vbCrLf & "This month never has this many days."
            blnError = True
        ElseIf Not blnError Then
            If cboType.ListIndex = Gregorian Then
                If txtDate = 29 And cboMonth.ListIndex = 1 And Not cGregorian.GregorianLeapYear(txtYear) Then
                    strError = strError & vbCrLf & "This date does not occur because it is not a leap year."
                    blnError = True
                End If
            ElseIf cboType.ListIndex = Julian Then
                If txtDate = 29 And cboMonth.ListIndex = 1 And Not cJulian.JulianLeapYear(txtYear, optCE) Then
                    strError = strError & vbCrLf & "This date does not occur because it is not a leap year."
                    blnError = True
                End If
            ElseIf cboType.ListIndex = Hebrew Then
                If cboMonth.ListIndex = 12 And Not cHebrew.HebrewLeapYear(txtYear) Then
                    strError = strError & vbCrLf & "Adar 2 does not occur because it is not a leap year."
                    blnError = True
                ElseIf cboMonth.ListIndex = 11 And txtDate = 30 And Not cHebrew.HebrewLeapYear(txtYear) Then
                    strError = strError & vbCrLf & "This date does not occur because it is not a leap year."
                    blnError = True
                ElseIf txtDate = 30 And (cboMonth.ListIndex = 7 And Not cHebrew.LongCheshvan(txtYear) Or cboMonth.ListIndex = 8 And cHebrew.ShortKislev(txtYear)) Then
                    strError = strError & vbCrLf & "This month only has 29 days in this year."
                    blnError = True
                End If
            ElseIf Not cboType.ListIndex = Islamic And txtDate = 30 And cboMonth.ListIndex = 11 And Not cIslamic.IslamicLeapYear(txtYear) Then
                    strError = strError & vbCrLf & "This date does not occur because it is not a leap year."
                    blnError = True
            End If
        End If
    End If
    If blnError Then
        MsgBox (strError)
    Else
        'The date is valid so store it
        udtDate.blnCE = optCE
        udtDate.dblDayNumber = txtDayNo
        udtDate.enmDateType = cboType.ListIndex
        udtDate.intDateOfMonth = txtDate
        udtDate.intMonth = cboMonth.ListIndex + 1
        udtDate.intYear = txtYear
        frmMain.cmdChangeTime.Enabled = (cboType.ListIndex = Gregorian Or cboType.ListIndex = Julian Or cboType.ListIndex = Hebrew Or cboType.ListIndex = Islamic)
        dblDate = EvaluateDate(udtDate)
        Unload Me
    End If
End Sub
Private Sub Form_Load()
    cboType.Clear
    cboType.AddItem ("Fixed")
    cboType.AddItem ("JD")
    cboType.AddItem ("JDE")
    cboType.AddItem ("MJD")
    cboType.AddItem ("Gregorian")
    cboType.AddItem ("Julian")
    cboType.AddItem ("Hebrew")
    cboType.AddItem ("Islamic")
    cboType.ListIndex = udtDate.enmDateType
    Call Update
    blnCancelled = False
End Sub
Private Function MonthName(intMonth As Integer, enmType As DateType, Optional intYear As Integer = -32767) As String
'Get the name of the month
    Dim cGregorian As New clsGregorian
    Dim cHebrew As New clsHebrew
    Dim cIslamic As New clsIslamic
    
    Select Case enmType
        Case Hebrew
            MonthName = cHebrew.MonthName(intMonth, intYear)
        Case Islamic
            MonthName = cIslamic.MonthName(intMonth)
        Case Else
            MonthName = cGregorian.MonthName(intMonth)
    End Select
End Function
Friend Function WriteDate(udtDateIn As MyDate) As String
'Convert a date to a string
    If udtDateIn.enmDateType = Gregorian Or udtDateIn.enmDateType = Julian Or udtDateIn.enmDateType = Hebrew Or udtDateIn.enmDateType = Islamic Then
        WriteDate = GetDayOfWeek(udtDateIn) & " "
        If udtDateIn.blnEve Then WriteDate = WriteDate & "eve "
        WriteDate = WriteDate & udtDateIn.intDateOfMonth & Th(udtDateIn.intDateOfMonth) & " " & MonthName(udtDateIn.intMonth, udtDateIn.enmDateType, udtDateIn.intYear) & " " & udtDateIn.intYear
        If udtDateIn.enmDateType = Julian Then
            If udtDateIn.blnCE Then
                WriteDate = WriteDate & " CE"
            Else
                WriteDate = WriteDate & " BCE"
            End If
        End If
    Else
        WriteDate = udtDateIn.dblDayNumber
    End If
    Select Case udtDateIn.enmDateType
        Case Fixed
            WriteDate = WriteDate & " Fixed Radix"
        Case JD
            WriteDate = WriteDate & " JD"
        Case JDE
            WriteDate = WriteDate & " JDE"
        Case mjd
            WriteDate = WriteDate & " MJD"
        Case Gregorian
            WriteDate = WriteDate & " Gregorian"
        Case Julian
            WriteDate = WriteDate & " Julian"
        Case Hebrew
            WriteDate = WriteDate & " Hebrew"
        Case Islamic
            WriteDate = WriteDate & " Islamic arithmetic"
    End Select
End Function
Friend Function GetDayOfWeek(udtDateIn As MyDate) As String
'Provide day name for a date
    Dim intDay As Integer
    
    intDay = MyMod(Int(EvaluateDate(udtDateIn)), 7)
    Select Case intDay
        Case 0
            GetDayOfWeek = "Sunday"
        Case 1
            GetDayOfWeek = "Monday"
        Case 2
            GetDayOfWeek = "Tuesday"
        Case 3
            GetDayOfWeek = "Wednesday"
        Case 4
            GetDayOfWeek = "Thursday"
        Case 5
            GetDayOfWeek = "Friday"
        Case 6
            GetDayOfWeek = "Saturday"
    End Select
End Function
Friend Function EvaluateDate(udtDate As MyDate) As Double
'Convert date to fixed radix day number for 0:00 UTC (Epoch 1/1/1 gregorian = 1)
    Dim cJD As New clsJD
    Dim cJDE As New clsJDE
    Dim cMJD As New clsMJD
    Dim cGregorian As New clsGregorian
    Dim cJulian As New clsJulian
    Dim cHebrew As New clsHebrew
    Dim cIslamic As New clsIslamic
    
    Select Case udtDate.enmDateType
        Case Fixed
            EvaluateDate = udtDate.dblDayNumber
        Case JD
            EvaluateDate = cJD.jd_fixed()
        Case JDE
            EvaluateDate = cJDE.jde_fixed(udtDate.dblDayNumber)
        Case mjd
            EvaluateDate = cMJD.mjd_fixed()
        Case Gregorian
            EvaluateDate = cGregorian.gregorian_fixed(udtDate)
        Case Julian
            EvaluateDate = cJulian.julian_fixed(udtDate)
        Case Hebrew
            EvaluateDate = cHebrew.hebrew_fixed(udtDate)
        Case Islamic
            EvaluateDate = cIslamic.Islamic_Fixed(udtDate)
        Case Else 'Invalid type
            Debug.Print "Error in DateToFixed, Invalid date type: " & udtDate.enmDateType
    End Select
End Function
Private Function Th(intI As Integer) As String
'Give ordinal suffix for an integer between 1 and 31
    If intI = 1 Or intI = 21 Or intI = 31 Then
        Th = "st"
    ElseIf intI = 2 Or intI = 22 Then
        Th = "nd"
    ElseIf intI = 3 Or intI = 23 Then
        Th = "rd"
    Else
        Th = "th"
    End If
End Function

Private Sub Form_Unload(Cancel As Integer)
    If Not blnCancelled Then Call cmdOK_Click
End Sub
Friend Function ToLngDate(dblDate As Double) As Long
    ToLngDate = Int(dblDate - frmMain.ZeroTime(dblDate, udtTime.enmTimeType))
End Function
Friend Function WriteDateTime(udtDate As MyDate, udtTime As Mytime, strOldDate As String) As String
    Dim strDate As String
    
    WriteDateTime = ""
    strDate = frmDate.WriteDate(udtDate)
    If StrComp(strDate, strOldDate) <> 0 Or udtDate.enmDateType < Gregorian Then
        WriteDateTime = strDate
        strOldDate = strDate
        If udtDate.enmDateType >= Gregorian Then WriteDateTime = WriteDateTime & " " & frmTime.WriteTime(udtTime, True)
    Else
        WriteDateTime = WriteDateTime & " " & frmTime.WriteTime(udtTime, False)
    End If
    If Not frmTime.Visible Then Unload frmTime
End Function
