VERSION 5.00
Begin VB.Form frmGraph 
   Caption         =   "Location of the Moon"
   ClientHeight    =   4500
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6705
   Icon            =   "frmGraph.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4500
   ScaleWidth      =   6705
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pctGraph 
      AutoRedraw      =   -1  'True
      BackColor       =   &H8000000E&
      DrawWidth       =   2
      Height          =   4095
      Left            =   120
      ScaleHeight     =   4035
      ScaleWidth      =   6315
      TabIndex        =   0
      Top             =   120
      Width           =   6375
   End
   Begin VB.Label lblGraph 
      Caption         =   "Moon: Red - not visible, Blue - May be visible, Black - Definately visible"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   4200
      Width           =   6015
   End
End
Attribute VB_Name = "frmGraph"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use

Dim curDisp As Object
Const intEarly = 30 'Minutes before first possible visibility
Private Type MyArray
    intN As Integer
    dblT(5) As Double
    MAZ() As Double
    MAL() As Double
End Type

Friend Sub DrawGraph(curDisplay As Object, Optional blnClear As Boolean = True, Optional dblYPosMin As Double = 0)
    Dim cMoon As New clsMoon
    Dim blnNew As Boolean
    Dim dblYallopQ As Double
    '0 Moon, 1 Sun, 2 Mercury, 3 Venus, 4 Jupiter
    Dim udtObj(4) As MyArray
    Dim blnEasy As Boolean
    Dim blnNotVisible As Boolean
    Dim dblProbVis As Double
    Dim dblTM As Double
    Dim udtMoon As HBody
    Dim intI As Integer
    Dim dblYMin As Double
    Dim dblYMax As Double
    Dim dblXMin As Double
    Dim dblXMax As Double
    Dim sngX0 As Double
    Dim sngX1 As Double
    Dim sngY0 As Double
    Dim sngY1 As Double
    Dim dblXRangeMin As Double
    Dim dblXRangeMax As Double
    Dim dblYRangeMin As Double
    Dim dblYRangeMax As Double
    Dim intX As Integer
    Dim intY As Integer
    Dim intTickLength As Integer
    Dim dblAngle As Double
    Dim dblSubtend As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim dblLength As Double
    Dim strLabel As String
    Dim lngFix As Long
    Dim cSun As New clsSun
    Dim udtBody As HBody
    Dim cPlanet As New clsPlanet
    
    If blnClear Then curDisplay.Cls
    'Moon
    lngFix = frmDate.ToLngDate(dblDate + dblTime)
    Call cMoon.Visibility(dblDate + dblTime, blnNew, dblYallopQ, udtObj(0).dblT, blnEasy, blnNotVisible, dblProbVis)
    If blnEasy Then
        If blnNew Then
            curDisplay.Print "The new Moon is visible for an extended period."
        Else
            curDisplay.Print "The old Moon is visible for an extended period."
        End If
    ElseIf blnNotVisible And dblYallopQ <= -0.23 Then
        If blnNew Then
            curDisplay.Print "The new Moon is not visible even with a telescope."
        Else
            curDisplay.Print "The old Moon is not visible even with a telescope."
        End If
    Else
        With udtObj(0)
            'set the time limit for the graph
            If blnNew Then
                'half hour before first possible sighting
                .dblT(4) = .dblT(0) - intEarly / 1440
            Else
                'half hour after last possible sighting
                .dblT(4) = .dblT(0) + intEarly / 1440
            End If
            'set the other time limit
            Call cMoon.RiseSet(lngFix, blnNew, True, .dblT(5), blnNeverRises, blnNeverSets, True)
            'If it is for the day before then repeat the calculation
            If .dblT(5) < .dblT(4) And .dblT(5) < .dblT(0) And blnNew Then
                Call cMoon.RiseSet(lngFix + 1, blnNew, True, .dblT(5), blnNeverRises, blnNeverSets, True)
            ElseIf .dblT(5) - .dblT(0) > 0.5 Then
                Call cMoon.RiseSet(lngFix - 1, blnNew, True, .dblT(5), blnNeverRises, blnNeverSets, True)
            End If
            If blnNew Then
                'Moon set
                .intN = Int((.dblT(5)) * 1440) - Int((.dblT(4)) * 1440 + 1)
            Else
                'Moon rise
                .intN = Int((.dblT(4)) * 1440) - Int((.dblT(5)) * 1440 + 1)
            End If
            'If .intN = 0 Then .intN = 1
            ReDim .MAZ(.intN)
            ReDim .MAL(.intN)
            'For each minute find the position of the center of the crescent
            For intI = 0 To .intN
                If blnNew Then
                    dblTM = Int((.dblT(4)) * 1440 + 1 + intI) / 1440
                Else
                    dblTM = Int((.dblT(5)) * 1440 + 1 + intI) / 1440
                End If
                Call cMoon.BrightLimb(dblTM, dblAngle, dblSubtend, .MAL(intI), .MAZ(intI))
            Next
        End With
        'Sun
        With udtObj(1)
            Call cSun.RiseSet(lngFix, blnNew, .dblT(5), True, blnNeverRises, blnNeverSets, 0, True)
            .dblT(4) = udtObj(0).dblT(4)
            If blnNew Then
                If .dblT(4) > .dblT(5) - intEarly / 1440 Then .dblT(4) = .dblT(5) - intEarly / 1440
                .intN = Int((.dblT(5)) * 1440) - Int((.dblT(4)) * 1440 + 1)
            Else
                If .dblT(4) < .dblT(5) + intEarly / 1440 Then .dblT(4) = .dblT(5) + intEarly / 1440
                .intN = Int((.dblT(4)) * 1440) - Int((.dblT(5)) * 1440 + 1)
            End If
            ReDim .MAZ(.intN)
            ReDim .MAL(.intN)
            For intI = 0 To .intN
                If blnNew Then
                    dblTM = Int((.dblT(4)) * 1440 + 1 + intI) / 1440
                Else
                    dblTM = Int((.dblT(5)) * 1440 + 1 + intI) / 1440
                End If
                Call cSun.TrueSun(dblTM, udtBody)
                .MAZ(intI) = udtBody.AzTopo
                .MAL(intI) = udtBody.AltRefr
            Next
        End With
        'Mercury
        With udtObj(2)
            If blnNew Then
                intI = 0
            Else
                intI = udtObj(0).intN
            End If
            dblTM = Int((udtObj(0).dblT(4)) * 1440 + 1) / 1440
            Call cPlanet.Planet("Mercury", dblTM, udtBody)
            'Moon appers before Mercury if it is above it or phase > 2%
            If sinD(udtObj(0).MAL(intI)) * sinD(udtBody.AltRefr) + cosD(udtObj(0).MAL(intI)) * cosD(udtBody.AltRefr) * cosD(udtObj(0).MAZ(intI) - udtBody.AzTopo) < 0.866 Or udtBody.AltRefr <= udtObj(0).MAL(intI) Then
                .intN = -1
            Else
                Call cMoon.TrueMoon(dblTM, udtBody)
                If udtBody.Phase > 0.02 Then
                    .intN = -1
                Else
                    .dblT(4) = udtObj(0).dblT(4)
                    Call cPlanet.RiseSet("Mercury", lngFix, blnNew, .dblT(5), True, blnNeverRises, blnNeverSets, 0, True)
                    If blnNew And .dblT(5) > udtObj(0).dblT(5) Or Not blnNew And .dblT(5) < udtObj(0).dblT(5) Then
                        .dblT(5) = udtObj(0).dblT(5)
                    End If
                    If blnNew Then
                        If .dblT(4) > .dblT(5) - intEarly / 1440 Then .dblT(4) = .dblT(5) - intEarly / 1440
                        .intN = Int((.dblT(5)) * 1440) - Int((.dblT(4)) * 1440 + 1)
                    Else
                        If .dblT(4) < .dblT(5) + intEarly / 1440 Then .dblT(4) = .dblT(5) + intEarly / 1440
                        .intN = Int((.dblT(4)) * 1440) - Int((.dblT(5)) * 1440 + 1)
                    End If
                    ReDim .MAZ(.intN)
                    ReDim .MAL(.intN)
                    For intI = 0 To .intN
                        If blnNew Then
                            dblTM = Int((.dblT(4)) * 1440 + 1 + intI) / 1440
                        Else
                            dblTM = Int((.dblT(5)) * 1440 + 1 + intI) / 1440
                        End If
                        Call cPlanet.Planet("Mercury", dblTM, udtBody)
                        .MAZ(intI) = udtBody.AzTopo
                        .MAL(intI) = udtBody.AltRefr
                    Next
                End If
            End If
        End With
        'Venus
        With udtObj(3)
            If blnNew Then
                intI = 0
            Else
                intI = udtObj(0).intN
            End If
            dblTM = Int((udtObj(0).dblT(4)) * 1440 + 1) / 1440
            Call cPlanet.Planet("Venus", dblTM, udtBody)
            'Moon appers before Venus if it is above or not far below it or phase > 3%
            If sinD(udtObj(0).MAL(intI)) * sinD(udtBody.AltRefr) + cosD(udtObj(0).MAL(intI)) * cosD(udtBody.AltRefr) * cosD(udtObj(0).MAZ(intI) - udtBody.AzTopo) < 0.866 Or udtBody.AltRefr <= udtObj(0).MAL(intI) - 5 Then
                .intN = -1
            Else
                Call cMoon.TrueMoon(dblTM, udtBody)
                If udtBody.Phase > 0.03 Then
                    .intN = -1
                Else
                    .dblT(4) = udtObj(0).dblT(4)
                    Call cPlanet.RiseSet("Venus", lngFix, blnNew, .dblT(5), True, blnNeverRises, blnNeverSets, 0, True)
                    If blnNew And .dblT(5) > udtObj(0).dblT(5) Or Not blnNew And .dblT(5) < udtObj(0).dblT(5) Then
                        .dblT(5) = udtObj(0).dblT(5)
                    End If
                    If blnNew Then
                        If .dblT(4) > .dblT(5) - intEarly / 1440 Then .dblT(4) = .dblT(5) - intEarly / 1440
                        .intN = Int((.dblT(5)) * 1440) - Int((.dblT(4)) * 1440 + 1)
                    Else
                        If .dblT(4) < .dblT(5) + intEarly / 1440 Then .dblT(4) = .dblT(5) + intEarly / 1440
                        .intN = Int((.dblT(4)) * 1440) - Int((.dblT(5)) * 1440 + 1)
                    End If
                    ReDim .MAZ(.intN)
                    ReDim .MAL(.intN)
                    For intI = 0 To .intN
                        If blnNew Then
                            dblTM = Int((.dblT(4)) * 1440 + 1 + intI) / 1440
                        Else
                            dblTM = Int((.dblT(5)) * 1440 + 1 + intI) / 1440
                        End If
                        Call cPlanet.Planet("Venus", dblTM, udtBody)
                        .MAZ(intI) = udtBody.AzTopo
                        .MAL(intI) = udtBody.AltRefr
                    Next
                End If
            End If
        End With
        'Jupiter
        With udtObj(4)
            If blnNew Then
                intI = 0
            Else
                intI = udtObj(0).intN
            End If
            dblTM = Int((udtObj(0).dblT(4)) * 1440 + 1) / 1440
            Call cPlanet.Planet("Jupiter", dblTM, udtBody)
            'Moon appers before Juptier if it is above it or phase > 2.5%
            If sinD(udtObj(0).MAL(intI)) * sinD(udtBody.AltRefr) + cosD(udtObj(0).MAL(intI)) * cosD(udtBody.AltRefr) * cosD(udtObj(0).MAZ(intI) - udtBody.AzTopo) < 0.866 Or udtBody.AltRefr <= udtObj(0).MAL(intI) Then
                .intN = -1
            Else
                Call cMoon.TrueMoon(dblTM, udtBody)
                If udtBody.Phase > 0.025 Then
                    .intN = -1
                Else
                    .dblT(4) = udtObj(0).dblT(4)
                    Call cPlanet.RiseSet("Jupiter", lngFix, blnNew, .dblT(5), True, blnNeverRises, blnNeverSets, 0, True)
                    If blnNew And .dblT(5) > udtObj(0).dblT(5) Or Not blnNew And .dblT(5) < udtObj(0).dblT(5) Then
                        .dblT(5) = udtObj(0).dblT(5)
                    End If
                    If blnNew Then
                        If .dblT(4) > .dblT(5) - intEarly / 1440 Then .dblT(4) = .dblT(5) - intEarly / 1440
                        .intN = Int((.dblT(5)) * 1440) - Int((.dblT(4)) * 1440 + 1)
                    Else
                        If .dblT(4) < .dblT(5) + intEarly / 1440 Then .dblT(4) = .dblT(5) + intEarly / 1440
                        .intN = Int((.dblT(4)) * 1440) - Int((.dblT(5)) * 1440 + 1)
                    End If
                    ReDim .MAZ(.intN)
                    ReDim .MAL(.intN)
                    For intI = 0 To .intN
                        If blnNew Then
                            dblTM = Int((.dblT(4)) * 1440 + 1 + intI) / 1440
                        Else
                            dblTM = Int((.dblT(5)) * 1440 + 1 + intI) / 1440
                        End If
                        Call cPlanet.Planet("Jupiter", dblTM, udtBody)
                        .MAZ(intI) = udtBody.AzTopo
                        .MAL(intI) = udtBody.AltRefr
                    Next
                End If
            End If
        End With
        With udtObj(0)
            dblYMin = MyMin(.MAL, .intN)
            dblYMax = MyMax(.MAL, .intN)
            dblXMin = MyMin(.MAZ, .intN)
            dblXMax = MyMax(.MAZ, .intN)
        End With
        For intI = 0 To 4
            With udtObj(intI)
                If .intN >= 0 Then
                    dblTM = MyMin(.MAL, .intN)
                    If dblTM < dblYMin Then dblYMin = dblTM
                    dblTM = MyMax(.MAL, .intN)
                    If dblTM > dblYMax Then dblYMax = dblTM
                    dblTM = MyMin(.MAZ, .intN)
                    If dblTM < dblXMin Then dblXMin = dblTM
                    dblTM = MyMax(.MAZ, .intN)
                    If dblTM > dblXMax Then dblXMax = dblTM
                End If
            End With
        Next
        'Find out the space required for the scale
        Call ScaleTextSize(dblXMin, dblXMax, intX, intY, "Azimuth", curDisplay)
        intTickLength = intY / 2
        dblYRangeMin = dblYPosMin
        dblYRangeMax = curDisplay.ScaleHeight - (intY + intTickLength)
        'Repeat for the Y-Scale
        Call ScaleTextSize(dblYMin, dblYMax, intX, intY, "Alt", curDisplay)
        intTickLength = intY / 2
        dblXRangeMin = (intX + intTickLength)
        dblXRangeMax = curDisplay.ScaleWidth
        curDisplay.ForeColor = vbBlack
        curDisplay.DrawWidth = 1
        'Draw the Y-Scale
        Call DrawScale(dblYMin, dblYMax, dblXRangeMin, dblYRangeMax, dblXRangeMin, dblYRangeMin, intTickLength, "Alt", curDisplay, dblYPosMin)
        'Draw the X-Scale
        Call DrawScale(dblXMin, dblXMax, dblXRangeMin, dblYRangeMax, CSng(curDisplay.ScaleWidth), dblYRangeMax, intTickLength, "Azimuth", curDisplay, dblYPosMin)
        Call DrawLine(udtObj(0).MAZ, udtObj(0).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(0).intN, udtObj(0).dblT, "Moon", blnNew, intTickLength, curDisplay)
        If udtObj(1).intN >= 0 Then Call DrawLine(udtObj(1).MAZ, udtObj(1).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(1).intN, udtObj(1).dblT, "Sun", blnNew, intTickLength, curDisplay)
        If udtObj(2).intN >= 0 Then Call DrawLine(udtObj(2).MAZ, udtObj(2).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(2).intN, udtObj(2).dblT, "Mercury", blnNew, intTickLength, curDisplay)
        If udtObj(3).intN >= 0 Then Call DrawLine(udtObj(3).MAZ, udtObj(3).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(3).intN, udtObj(3).dblT, "Venus", blnNew, intTickLength, curDisplay)
        If udtObj(4).intN >= 0 Then Call DrawLine(udtObj(4).MAZ, udtObj(4).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(4).intN, udtObj(4).dblT, "Jupiter", blnNew, intTickLength, curDisplay)
    End If
End Sub
Private Sub DrawLine(dblX() As Double, dblY() As Double, dblXMin As Double, dblXMax As Double, dblYMin As Double, dblYMax As Double, dblXRangeMin As Double, dblXRangeMax As Double, dblYRangeMin As Double, dblYRangeMax As Double, intN As Integer, dblT() As Double, strLabel As String, blnNew As Boolean, intTickLength As Integer, curDisplay As Object)
    Dim intI As Integer
    Dim dblTM As Double
    Dim sngX0 As Single
    Dim sngX1 As Single
    Dim sngY0 As Single
    Dim sngY1 As Single
    Dim dblLength As Double
    Dim strTime As String
    Dim intJ As Integer
    Dim cLocalT As New clsLocalTime
    Dim udtTimeIn As Mytime
    
    For intI = 1 To intN
        If blnNew Then
            dblTM = Int((dblT(4)) * 1440 + 1 + intI) / 1440
            If (dblTM < dblT(0) Or dblTM > dblT(3)) And strLabel = "Moon" Then
                curDisplay.ForeColor = vbRed
            ElseIf (dblTM < dblT(1) Or dblTM > dblT(2)) And strLabel = "Moon" Then
                curDisplay.ForeColor = vbBlue
            Else
                curDisplay.ForeColor = vbBlack
            End If
        Else
            dblTM = Int((dblT(5)) * 1440 + 1 + intI) / 1440
            If (dblTM < dblT(3) Or dblTM > dblT(0)) And strLabel = "Moon" Then
                curDisplay.ForeColor = vbRed
            ElseIf (dblTM < dblT(2) Or dblTM > dblT(1)) And strLabel = "Moon" Then
                curDisplay.ForeColor = vbBlue
            Else
                curDisplay.ForeColor = vbBlack
            End If
        End If
        sngX0 = (dblX(intI - 1) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
        sngY0 = (1 - (dblY(intI - 1) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
        sngX1 = (dblX(intI) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
        sngY1 = (1 - (dblY(intI) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
        curDisplay.Line (sngX0, sngY0)-(sngX1, sngY1)
        If MyMod(dblTM * 1440, 10) = 0 Then
            dblLength = Sqr(Square(sngX1 - sngX0) + Square(sngY1 - sngY0))
            If udtLocation.dblLatitude >= 0 Then
                curDisplay.Line (sngX0, sngY0)-(sngX0 + (sngY1 - sngY0) * intTickLength / dblLength, sngY0 - (sngX1 - sngX0) * intTickLength / dblLength)
            Else
                curDisplay.Line (sngX0, sngY0)-(sngX0 - (sngY1 - sngY0) * intTickLength / dblLength, sngY0 + (sngX1 - sngX0) * intTickLength / dblLength)
            End If
            Call cLocalT.ToLocal(dblTM + 0.00048, udtTimeIn)
            strTime = udtTimeIn.udtDms.intDegreesHours & ":" & Format(udtTimeIn.udtDms.intMinutes, "00")
            curDisplay.CurrentY = curDisplay.CurrentY - curDisplay.TextHeight(strLabel)
            If Not blnNew And udtLocation.dblLatitude >= 0 Or blnNew And udtLocation.dblLatitude < 0 Then curDisplay.CurrentX = curDisplay.CurrentX - curDisplay.TextWidth(strLabel)
            curDisplay.Print strTime
        End If
    Next
    'Put a label under the line
    curDisplay.ForeColor = vbBlack
    For intI = 1 To Len(strLabel)
        intJ = intN * intI / (Len(strLabel) + 1) - 1
        curDisplay.CurrentX = (dblX(intJ) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
        If blnNew Then curDisplay.CurrentX = curDisplay.CurrentX - curDisplay.TextWidth(Mid(strLabel, intI, 1))
        curDisplay.CurrentY = (1 - (dblY(intJ) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
        curDisplay.Print Mid(strLabel, intI, 1)
    Next
End Sub
Private Sub DrawScale(dblMin As Double, dblMax As Double, sngXmin As Double, sngYMin As Double, sngXMax As Double, sngYMax As Double, intTickLength As Integer, strLabel As String, curDisplay As Object, dblYPosMin As Double)
    'Draw a scale
    'Checked 23.11.99
    'dblMin and dblMax are the values at the ends of the scale
    '(sngXmin, sngYmin) and (sngXMax, sngYMax) are the ends of the scale in pixels
    'intTickLength is the tick length in pixels
    'strLabel is the label, usually the units
    Dim blnVertical As Boolean 'True if scale closer to vertical than horizontal
    Dim dblRange As Double 'difference in values at ends of the scale
    Dim dblMantissa As Double 'Mantissa part of step in label values before rounding
    Dim dblStep As Double 'Step in label values
    Dim dblTick As Double
    Dim intExponent As Integer 'Exponent part of step in label values
    Dim intMantissa As Integer 'Mantissa part of step in label values
    Dim intSgn As Integer 'Direction of scale: -1 high to low, 1 low to high
    Dim lngTick As Long 'Label number
    Dim sngXEnd As Single
    Dim sngXStart As Single
    Dim sngYEnd As Single
    Dim sngYStart As Single
    
    blnVertical = Abs(sngYMax - sngYMin) > Abs(sngXMax - sngXmin) 'True if scale closer to vertical than horizontal
    dblRange = dblMax - dblMin 'Determine the range of values
    If dblRange >= 0 Then 'Determine the direction of the scale
        intSgn = 1
    Else
        intSgn = -1
    End If
    'Determine the step size
    intExponent = Int(Log10(intSgn * dblRange / 2.5))
    dblMantissa = dblRange / 2.5 / 10 ^ intExponent
    If Abs(dblMantissa) < 2 Then
        intMantissa = 1
    ElseIf Abs(dblMantissa) < 5 Then
        intMantissa = 2
    Else
        intMantissa = 5
    End If
    dblStep = intSgn * intMantissa * 10 ^ intExponent
    curDisplay.Line (sngXmin, sngYMin)-(sngXMax, sngYMax) 'Draw the scale line
    For lngTick = Int(dblMin / dblStep + 1) To Int(dblMax / dblStep) 'For each step
        dblTick = lngTick * dblStep 'Calculate the value
        'Determine position of tick
        sngXStart = (dblTick - dblMin) * (sngXMax - sngXmin) / (dblMax - dblMin) + sngXmin
        sngYStart = (dblTick - dblMin) * (sngYMax - sngYMin) / (dblMax - dblMin) + sngYMin
        If blnVertical Then
            sngXEnd = sngXStart - intTickLength
            sngYEnd = sngYStart
        Else
            sngXEnd = sngXStart
            sngYEnd = sngYStart + intTickLength
        End If
        curDisplay.Line (sngXStart, sngYStart)-(sngXEnd, sngYEnd) 'Draw the tick mark
        'Determine starting position of text
        If blnVertical Then
            curDisplay.CurrentX = sngXEnd - curDisplay.TextWidth(dblTick)
            curDisplay.CurrentY = sngYEnd - curDisplay.TextHeight(dblTick) / 2
        Else
            curDisplay.CurrentX = sngXEnd - curDisplay.TextWidth(dblTick) / 2
            curDisplay.CurrentY = sngYEnd
        End If
'        lblOutput.Caption = lblOutput.Caption & vbCrLf & pctDisplay.TextWidth(dblTick)
'        lblOutput.Caption = lblOutput.Caption & ", " & pctDisplay.TextHeight(dblTick)
        If blnVertical Then 'If there is room to print the value do so
            If curDisplay.CurrentY < curDisplay.ScaleHeight - curDisplay.TextHeight(dblTick) And curDisplay.CurrentY >= curDisplay.TextHeight(strLabel) Then
                curDisplay.Print dblTick
            End If
        Else
            If curDisplay.CurrentX > curDisplay.TextWidth(strLabel) + sngXmin And curDisplay.CurrentX < curDisplay.ScaleWidth - curDisplay.TextWidth(dblTick) Then
                curDisplay.Print dblTick
            End If
        End If
    Next
    If blnVertical Then 'Print the text label
        curDisplay.CurrentX = 0
        curDisplay.CurrentY = dblYPosMin
        curDisplay.Print strLabel
    Else
        curDisplay.CurrentX = sngXmin
        curDisplay.CurrentY = sngYMin + intTickLength
        curDisplay.Print strLabel
    End If
    'Draw grid
    For lngTick = Int(dblMin + 1) To Int(dblMax)
        sngXStart = (lngTick - dblMin) * (sngXMax - sngXmin) / (dblMax - dblMin) + sngXmin
        sngYStart = (lngTick - dblMin) * (sngYMax - sngYMin) / (dblMax - dblMin) + sngYMin
        If blnVertical Then
            sngXEnd = curDisplay.ScaleWidth
            sngYEnd = sngYStart
        Else
            sngXEnd = sngXStart
            sngYEnd = dblYPosMin
        End If
        If MyMod(lngTick, 5) = 0 Then
            curDisplay.DrawStyle = 1
        Else
            curDisplay.DrawStyle = 2
        End If
        curDisplay.ForeColor = &HAAAAAA 'Light grey grid suggested by Michael Isaacs
        curDisplay.Line (sngXStart, sngYStart)-(sngXEnd, sngYEnd) 'Draw the tick mark
        curDisplay.DrawStyle = 0
        curDisplay.ForeColor = vbBlack
    Next
End Sub
Private Sub ScaleTextSize(dblMin As Double, dblMax As Double, intXText As Integer, intYText As Integer, strLabel As String, curDisplay As Object)
    Dim dblRange As Double
    Dim intSgn As Integer
    Dim intExponent As Integer
    Dim dblMantissa As Double
    Dim intMantissa As Double
    Dim dblTick As Double
    Dim lngTick As Long
    Dim dblStep As Double
    'Finds the maximum width and height of the numbers on the scale
    'Checked 2.12.99
    
    intXText = curDisplay.TextWidth(strLabel)
    intYText = curDisplay.TextHeight(strLabel)
    dblRange = dblMax - dblMin
    If dblRange >= 0 Then
        intSgn = 1
    Else
        intSgn = -1
    End If
    intExponent = Int(Log10(intSgn * dblRange / 2.5))
    dblMantissa = dblRange / 2.5 / 10 ^ intExponent
    If Abs(dblMantissa) < 2 Then
        intMantissa = 1
    ElseIf Abs(dblMantissa) < 5 Then
        intMantissa = 2
    Else
        intMantissa = 5
    End If
    dblStep = intSgn * intMantissa * 10 ^ intExponent
    For lngTick = Int(dblMin / dblStep + 1) To Int(dblMax / dblStep)
        dblTick = lngTick * dblStep
        If curDisplay.TextWidth(dblTick) > intXText Then
            intXText = curDisplay.TextWidth(dblTick)
        End If
        If curDisplay.TextHeight(dblTick) > intYText Then
            intYText = curDisplay.TextHeight(dblTick)
        End If
    Next
End Sub
Function MyMax(dblArray() As Double, intN As Integer) As Double
    Dim intI As Integer
    
    MyMax = dblArray(0)
    For intI = 1 To intN
        If MyMax < dblArray(intI) Then MyMax = dblArray(intI)
    Next
End Function
Function MyMin(dblArray() As Double, intN As Integer) As Double
    Dim intI As Integer
    
    MyMin = dblArray(0)
    For intI = 1 To intN
        If MyMin > dblArray(intI) Then MyMin = dblArray(intI)
    Next
End Function

Private Sub Form_Load()
    Call Form_Resize
End Sub

Friend Sub Form_Resize()
    If frmGraph.Width > 270 And frmGraph.Height > 900 Then
        pctGraph.Width = frmGraph.Width - 240
        pctGraph.Height = frmGraph.Height - 850
        lblGraph.Top = frmGraph.ScaleHeight - 300
        Call DrawGraph(pctGraph)
    End If
End Sub
