VERSION 5.00
Begin VB.Form frmTime 
   Caption         =   "Time"
   ClientHeight    =   1770
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3360
   Icon            =   "frmTime.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1770
   ScaleWidth      =   3360
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtSeconds 
      Height          =   288
      Left            =   840
      TabIndex        =   18
      Text            =   "0"
      Top             =   840
      Width           =   1212
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   255
      Left            =   2400
      TabIndex        =   17
      Top             =   1440
      Width           =   855
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   255
      Left            =   2400
      TabIndex        =   16
      Top             =   1080
      Width           =   855
   End
   Begin VB.Frame fra24Hr 
      Height          =   615
      Left            =   2160
      TabIndex        =   13
      Top             =   360
      Width           =   1095
      Begin VB.OptionButton opt24Hr 
         Caption         =   "24 hr"
         Height          =   192
         Left            =   120
         TabIndex        =   15
         Top             =   360
         Value           =   -1  'True
         Width           =   855
      End
      Begin VB.OptionButton optAmPm 
         Caption         =   "am/pm"
         Height          =   195
         Left            =   120
         TabIndex        =   14
         Top             =   120
         Width           =   855
      End
   End
   Begin VB.Frame fraNTime 
      Height          =   615
      Left            =   0
      TabIndex        =   10
      Top             =   1080
      Width           =   1215
      Begin VB.OptionButton opt2 
         Caption         =   "2nd time"
         Height          =   192
         Left            =   120
         TabIndex        =   12
         Top             =   360
         Width           =   975
      End
      Begin VB.OptionButton opt1 
         Caption         =   "1st time"
         Height          =   252
         Left            =   120
         TabIndex        =   11
         Top             =   120
         Value           =   -1  'True
         Width           =   852
      End
   End
   Begin VB.Frame fraAMPM 
      Height          =   615
      Left            =   1320
      TabIndex        =   7
      Top             =   1080
      Width           =   975
      Begin VB.OptionButton optAM 
         Caption         =   "a.m."
         Height          =   192
         Left            =   120
         TabIndex        =   9
         Top             =   120
         Value           =   -1  'True
         Width           =   735
      End
      Begin VB.OptionButton optPM 
         Caption         =   "p.m."
         Height          =   192
         Left            =   120
         TabIndex        =   8
         Top             =   360
         Width           =   735
      End
   End
   Begin VB.TextBox txtMinutes 
      Height          =   288
      Left            =   840
      TabIndex        =   6
      Text            =   "0"
      Top             =   600
      Width           =   1212
   End
   Begin VB.TextBox txtHours 
      Height          =   288
      Left            =   840
      TabIndex        =   5
      Text            =   "12"
      Top             =   360
      Width           =   1212
   End
   Begin VB.ComboBox cboTimeType 
      Height          =   315
      Left            =   840
      TabIndex        =   4
      Text            =   "UTC"
      Top             =   0
      Width           =   1452
   End
   Begin VB.Label lblTimeType 
      Caption         =   "Time Type"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Width           =   855
   End
   Begin VB.Label lblHours 
      Caption         =   "Hours"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   360
      Width           =   855
   End
   Begin VB.Label lblMinutes 
      Caption         =   "Minutes"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   600
      Width           =   855
   End
   Begin VB.Label lblSeconds 
      Caption         =   "Seconds"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   840
      Width           =   855
   End
End
Attribute VB_Name = "frmTime"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use

Dim blnCancelled As Boolean

Friend Sub EvaluateTime(blnValid As Boolean)
'Convert time to number of days after UTC midnight at the start of or during the current day
    Dim cLocalTime As New clsLocalTime
    Dim cMeanSolar As New clsMeanSolar
    Dim cUTC As New clsUTC
    Dim cGMST As New clsGMST
    Dim cLST As New clsLST
    Dim cTrueSolar As New clsTrueSolar
    Dim cSeasonal As New clsSeasonal
    
    'Select the appropriate conversion routine
    Select Case udtTime.enmTimeType
    Case utc
        dblTime = cUTC.FromUTC(udtTime, blnValid)
    Case localt
        dblTime = cLocalTime.FromLocal(udtTime, blnValid)
    Case meansolar
        dblTime = cMeanSolar.FromMeanSolar(udtTime, blnValid)
    Case gmst
        dblTime = cGMST.FromGMST(udtTime, blnValid)
    Case lst
        dblTime = cLST.FromLST(udtTime, blnValid)
    Case truesolar
        dblTime = cTrueSolar.FromTrueSolar(udtTime, blnValid)
    Case seasonal
        dblTime = cSeasonal.FromSeasonal(udtTime, blnValid)
    Case Else 'Invalid type
        Debug.Print "Error in TimeToFixed, Invalid time type: " & udtTime.enmTimeType
    End Select
End Sub

Private Sub Update()
'Update the form according to udtTime
    opt24Hr = udtTime.bln24Hr
    optAmPm = Not udtTime.bln24Hr
    optAM = Not udtTime.blnPM
    optPM = udtTime.blnPM
    opt1 = Not udtTime.blnSecondTime
    opt2 = udtTime.blnSecondTime
    txtHours = udtTime.udtDms.intDegreesHours
    txtMinutes = udtTime.udtDms.intMinutes
    txtSeconds = udtTime.udtDms.dblSeconds
    If cboTimeType.ListIndex = seasonal Then
        optAM.Caption = "Night"
        optPM.Caption = "Day"
    Else
        optAM.Caption = "a.m."
        optPM.Caption = "p.m."
    End If
End Sub

Private Sub cboTimeType_Click()
'Change in time type
    'AM/PM only apply to UTC, Local, mean and true solar times
    opt24Hr.Enabled = (cboTimeType.ListIndex = utc Or cboTimeType.ListIndex = localt Or cboTimeType.ListIndex = meansolar Or cboTimeType.ListIndex = truesolar)
    optAmPm.Enabled = opt24Hr.Enabled
    'optAM and optPM are used to select day and night for seasonal time
    optAM.Enabled = (opt24Hr.Enabled Or cboTimeType.ListIndex = seasonal)
    optPM.Enabled = optAM.Enabled
    If cboTimeType.ListIndex = seasonal Then
        optAM.Caption = "Night"
        optPM.Caption = "Day"
    Else
        optAM.Caption = "AM"
        optPM.Caption = "PM"
    End If
End Sub

Private Sub cmdCancel_Click()
    blnCancelled = True
    Unload Me
End Sub

Private Sub cmdOK_Click()
    Dim blnError As Boolean 'Indicates that the time cannot be valid
    Dim strError As String
    
    blnError = False
    strError = "Time cannot be valid"
    'Hours
    If Not IsNumeric(txtHours) Then
        strError = strError & vbCrLf & "Hours must be a number."
        blnError = True
    ElseIf txtHours >= 24 Or txtHours < 0 Then
        strError = strError & vbCrLf & "Hours must between 0 and 23."
        blnError = True
    ElseIf txtHours <> Int(txtHours) Then
        strError = strError & vbCrLf & "Hours must be an integer."
        blnError = True
    ElseIf optAmPm And cboTimeType.ListIndex < gmst And (txtHours = 0 Or txtHours >= 13) Or cboTimeType.ListIndex = seasonal And txtHours >= 12 Then
        If cboTimeType.ListIndex = seasonal Then
            strError = strError & vbCrLf & "When using seasonal time then Hours must be between 0 and 11."
        Else
            strError = strError & vbCrLf & "When in am/pm mode then Hours must be between 1 and 12."
        End If
        blnError = True
    End If
    'Minutes
    If Not IsNumeric(txtMinutes) Then
        strError = strError & vbCrLf & "Minutes must be numeric."
        blnError = True
    ElseIf txtMinutes < 0 Or txtMinutes >= 60 Then
        strError = strError & vbCrLf & "Minutes must be between 0 and 59."
        blnError = True
    ElseIf txtMinutes <> Int(txtMinutes) Then
        strError = strError & vbCrLf & "Minutes must be an integer."
        blnError = True
    End If
    'Seconds
    If Not IsNumeric(txtSeconds) Then
        strError = strError & vbCrLf & "Seconds must be numeric."
        blnError = True
    ElseIf txtSeconds < 0 Or txtSeconds >= 60 Then
        strError = strError & vbCrLf & "Seconds must be between 0 and less than 60."
        blnError = True
    End If
    If blnError Then
        MsgBox (strError)
    Else
        udtTime.bln24Hr = opt24Hr
        udtTime.blnPM = optPM
        udtTime.blnSecondTime = opt2
        udtTime.enmTimeType = cboTimeType.ListIndex
        If udtTime.enmTimeType = seasonal Then
            udtTime.bln24Hr = False
        ElseIf udtTime.enmTimeType = gmst Or udtTime.enmTimeType = lst Then
            udtTime.bln24Hr = True
        End If
        udtTime.udtDms.blnSign = True
        udtTime.udtDms.dblSeconds = txtSeconds
        udtTime.udtDms.intDegreesHours = txtHours
        udtTime.udtDms.intMinutes = txtMinutes
        Unload Me
    End If
End Sub
Friend Function WriteTime(udtTimeIn As Mytime, Optional blnTimeType As Boolean = True) As String
'Turn time into string
    If udtTime.bln24Hr Then
        WriteTime = Format(udtTimeIn.udtDms.intDegreesHours, "00")
    Else
        WriteTime = udtTimeIn.udtDms.intDegreesHours
    End If
    WriteTime = WriteTime & ":" & Format(udtTimeIn.udtDms.intMinutes, "00") & ":"
    If Right(Format(udtTimeIn.udtDms.dblSeconds, "00.0"), 1) = "0" Then
        WriteTime = WriteTime & Format(udtTimeIn.udtDms.dblSeconds, "00")
    Else
        WriteTime = WriteTime & Format(udtTimeIn.udtDms.dblSeconds, "00.0")
    End If
    If Not udtTimeIn.bln24Hr Then
        If udtTimeIn.enmTimeType = seasonal Then
            If udtTimeIn.blnPM Then
                WriteTime = WriteTime & " day"
            Else
                WriteTime = WriteTime & " night"
            End If
        Else
            If udtTimeIn.blnPM Then
                WriteTime = WriteTime & " p.m."
            Else
                WriteTime = WriteTime & " a.m."
            End If
        End If
    End If
    If udtTimeIn.blnSecondTime Then
        WriteTime = WriteTime & " 2nd ocurrence"
    End If
    If blnTimeType Then
        Select Case udtTimeIn.enmTimeType
            Case utc
                WriteTime = WriteTime & " UTC"
            Case localt
                WriteTime = WriteTime & " Local Time"
            Case meansolar
                WriteTime = WriteTime & " Mean Solar Time"
            Case truesolar
                WriteTime = WriteTime & " True Solar Time"
            Case gmst
                WriteTime = WriteTime & " GMST"
            Case lst
                WriteTime = WriteTime & " LST"
            Case seasonal
                WriteTime = WriteTime & " Seasonal"
        End Select
    End If
End Function
Private Sub Form_Load()
    cboTimeType.Clear
    cboTimeType.AddItem ("UTC")
    cboTimeType.AddItem ("Local")
    cboTimeType.AddItem ("Mean Solar")
    cboTimeType.AddItem ("True Solar")
    cboTimeType.AddItem ("GMST")
    cboTimeType.AddItem ("LST")
    cboTimeType.AddItem ("Seasonal")
    cboTimeType.ListIndex = udtTime.enmTimeType
    'Copy variable to form settings
    Call Update
    blnCancelled = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If Not blnCancelled Then Call cmdOK_Click
End Sub
Friend Sub ToAMPM(udtTimeIn As Mytime)
'Converts a 24 hour time into an AM/PM (Night/Day for seasonal) time
    udtTimeIn.blnPM = udtTimeIn.udtDms.intDegreesHours >= 12
    If udtTimeIn.enmTimeType = seasonal Then
        udtTimeIn.bln24Hr = False
    ElseIf udtTimeIn.enmTimeType = gmst Or udtTimeIn.enmTimeType = lst Then
        udtTimeIn.bln24Hr = True
    Else
        udtTimeIn.bln24Hr = udtTime.bln24Hr
    End If
    If udtTimeIn.bln24Hr And udtTimeIn.enmTimeType = seasonal Then
        MsgBox ("Time must not be in 24 hour mode for seasonal type")
    ElseIf Not udtTimeIn.bln24Hr And (udtTimeIn.enmTimeType = gmst Or udtTimeIn.enmTimeType = lst) Then
        MsgBox ("Time must be in 24 hour mode for GMST and LST type")
    End If
    If Not udtTimeIn.bln24Hr Then
        If udtTimeIn.udtDms.intDegreesHours = 0 And udtTimeIn.enmTimeType <> seasonal Then
            udtTimeIn.udtDms.intDegreesHours = 12
        ElseIf udtTimeIn.udtDms.intDegreesHours > 12 Or udtTimeIn.udtDms.intDegreesHours = 12 And udtTimeIn.enmTimeType = seasonal Then
            udtTimeIn.udtDms.intDegreesHours = udtTimeIn.udtDms.intDegreesHours - 12
        End If
    End If
End Sub
Friend Function FromAMPM(udtTimeIn As Mytime) As Double
'Get a value from a mytime type in hours
    Dim cDMS As New clsDMS
    
    If udtTimeIn.bln24Hr And udtTimeIn.enmTimeType = seasonal Then
        MsgBox ("Time must not be in 24 hour mode for seasonal type")
    ElseIf Not udtTimeIn.bln24Hr And (udtTimeIn.enmTimeType = gmst Or udtTimeIn.enmTimeType = lst) Then
        MsgBox ("Time must be in 24 hour mode for GMST and LST type")
    End If
    FromAMPM = cDMS.FromDMS(udtTimeIn.udtDms)
    If Not udtTimeIn.bln24Hr Then
        If udtTimeIn.udtDms.intDegreesHours = 12 And Not udtTimeIn.blnPM Then
            FromAMPM = FromAMPM - 12
        ElseIf udtTimeIn.blnPM And udtTimeIn.udtDms.intDegreesHours < 12 Then
            FromAMPM = FromAMPM + 12
        End If
    End If
    If udtTimeIn.blnSecondTime Then
        FromAMPM = FromAMPM + 24
    End If
End Function
Friend Function SubTime(udtTime1 As Mytime, udtTime2 As Mytime) As Double
'Subtract two times and give answer in days
    Dim dblTime1 As Double
    Dim dblTime2 As Double
    
    'evaluate times
    dblTime1 = FromAMPM(udtTime1)
    dblTime2 = FromAMPM(udtTime2)
    'subtract and convert to days
    SubTime = (dblTime1 - dblTime2) / 24
End Function
