VERSION 5.00
Begin VB.Form frmWeather 
   Caption         =   "Weather"
   ClientHeight    =   2010
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3585
   Icon            =   "frmWeather.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   2010
   ScaleWidth      =   3585
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   255
      Left            =   1920
      TabIndex        =   18
      Top             =   120
      Width           =   735
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   255
      Left            =   2760
      TabIndex        =   17
      Top             =   120
      Width           =   735
   End
   Begin VB.TextBox txtHA 
      Height          =   285
      Left            =   2640
      TabIndex        =   16
      Text            =   "20"
      Top             =   1680
      Width           =   495
   End
   Begin VB.TextBox txtHD 
      Height          =   285
      Left            =   2040
      TabIndex        =   15
      Text            =   "20"
      Top             =   1680
      Width           =   495
   End
   Begin VB.TextBox txtHM 
      Height          =   285
      Left            =   1440
      TabIndex        =   14
      Text            =   "60"
      Top             =   1680
      Width           =   495
   End
   Begin VB.TextBox txtPA 
      Height          =   285
      Left            =   2640
      TabIndex        =   13
      Text            =   "7"
      Top             =   1320
      Width           =   495
   End
   Begin VB.TextBox txtPD 
      Height          =   285
      Left            =   2040
      TabIndex        =   12
      Text            =   "0"
      Top             =   1320
      Width           =   495
   End
   Begin VB.TextBox txtPM 
      Height          =   285
      Left            =   1440
      TabIndex        =   11
      Text            =   "922"
      Top             =   1320
      Width           =   495
   End
   Begin VB.TextBox txtTA 
      Height          =   285
      Left            =   2640
      TabIndex        =   10
      Text            =   "18"
      Top             =   960
      Width           =   495
   End
   Begin VB.TextBox txtTD 
      Height          =   285
      Left            =   2040
      TabIndex        =   9
      Text            =   "7"
      Top             =   960
      Width           =   495
   End
   Begin VB.TextBox txtTM 
      Height          =   285
      Left            =   1440
      TabIndex        =   8
      Text            =   "16"
      Top             =   960
      Width           =   495
   End
   Begin VB.ComboBox cboBasis 
      Height          =   288
      Left            =   600
      TabIndex        =   0
      Text            =   "Global"
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label lblAnnual 
      Caption         =   "Annual range"
      Height          =   492
      Left            =   2640
      TabIndex        =   7
      Top             =   480
      Width           =   492
   End
   Begin VB.Label lblDaily 
      Caption         =   "Daily range"
      Height          =   492
      Left            =   2040
      TabIndex        =   6
      Top             =   480
      Width           =   492
   End
   Begin VB.Label lblMean 
      Caption         =   "Mean"
      Height          =   252
      Left            =   1440
      TabIndex        =   5
      Top             =   480
      Width           =   492
   End
   Begin VB.Label lblHumidity 
      Caption         =   "Humidity (%)"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Label lblPressure 
      Caption         =   "Pressure (mbar)"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label lblTemperature 
      Caption         =   "Temperature (C)"
      Height          =   252
      Left            =   0
      TabIndex        =   2
      Top             =   960
      Width           =   1332
   End
   Begin VB.Label lblBasis 
      Caption         =   "Basis"
      Height          =   252
      Left            =   0
      TabIndex        =   1
      Top             =   120
      Width           =   492
   End
End
Attribute VB_Name = "frmWeather"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use

Dim blnCancelled As Boolean

Public Sub GetMeanWeather()
'Get average weather for the current location
    Dim dblMinDistance As Double
    Dim dblDistance As Double
    Dim dblHeightDif As Double
    Dim intCountry As Integer
    Dim intCity As Integer
    Dim intNeighborhood As Integer
    Dim dblHeightDiff As Double
    
    Select Case cboBasis.ListIndex
        Case Manual 'Use the entered parameters
            udtWeatherNow.dblHumidity = udtWeather.udtClimate.udtHumidity.dblMean
            udtWeatherNow.dblPressure = udtWeather.udtClimate.udtPressure.dblMean
            udtWeatherNow.dblTemperature = udtWeather.udtClimate.udtTemperature.dblMean
        Case GlobalW 'Based on global approximation
            udtWeatherNow.dblHumidity = 50 'Default value
            udtWeatherNow.dblPressure = 1010 + 10 * sinD(2 * udtPosition.dblLatitude) 'Good above 45S
            If udtPosition.dblLatitude < -45 Then 'Correct for low pressure in the Antarctic
                udtWeatherNow.dblPressure = udtWeatherNow.dblPressure + (udtPosition.dblLatitude + 45) / 3
            End If
            udtWeatherNow.dblPressure = udtWeatherNow.dblPressure / Exp(udtPosition.dblHeight / 7143) 'Adjust for height above sea level
            udtWeatherNow.dblTemperature = 27 - Abs(udtPosition.dblLatitude) * 0.467 - udtPosition.dblHeight * 0.005688 'Estimate temperature
        Case LocalW
            dblMinDistance = 1000000 'Impossibly large
            'Find closest location
            For intCountry = 0 To udtLocationData.intNStatesCountries - 1
                For intCity = 0 To udtLocationData.udtCountryState(intCountry).intNCities - 1
                    For intNeighborhood = 0 To udtLocationData.udtCountryState(intCountry).udtCity(intCity).intNNeighborhoods - 1
                        With udtLocationData.udtCountryState(intCountry).udtCity(intCity).udtNeighborhood(intNeighborhood).udtPosition
                            dblDistance = sinD(.dblLatitude) * sinD(udtPosition.dblLatitude) + cosD(.dblLatitude) * cosD(udtPosition.dblLatitude) * cosD(.dblLongitude - udtPosition.dblLongitude)
                            If dblDistance > 0.999995 Then
                                dblDistance = 117.48 * Sqr(Square(udtPosition.dblLongitude - .dblLongitude) * cosD((.dblLatitude + udtPosition.dblLatitude) / 2) + Square(.dblLatitude - udtPosition.dblLatitude))
                            ElseIf dblDistance <= -1 Then
                                dblDistance = 20015.19
                            Else
                                dblDistance = 117.48 * acosD(dblDistance)
                            End If
                            dblHeightDiff = udtPosition.dblHeight - .dblHeight
                        End With
                        If dblDistance < dblMinDistance Then
                            dblMinDistance = dblDistance
                            'Set the weahter parameters adjusting for change in height above sea level
                            With udtLocationData.udtCountryState(intCountry).udtCity(intCity).udtNeighborhood(intNeighborhood).udtLocalClimate
                                udtWeatherNow.dblHumidity = .udtHumidity.dblMean
                                udtWeatherNow.dblPressure = .udtPressure.dblMean / Exp(dblHeightDiff / 7143)
                                udtWeatherNow.dblTemperature = .udtTemperature.dblMean - dblHeightDiff * 0.005688
                            End With
                        End If
                    Next
                Next
            Next
        Case Else
            MsgBox ("Invalid Weather Basis.")
    End Select
End Sub
Friend Sub GetWeatherNow(dblDate As Double, dblTime As Double, udtWeatherNow As WeatherNow)
'Get weather appropriate for the current location and time
    Dim dblMinDistance As Double
    Dim dblDistance As Double
    Dim dblHeightDif As Double
    Dim intCountry As Integer
    Dim intCity As Integer
    Dim intNeighborhood As Integer
    Dim dblAnnual As Double
    Dim dblDaily As Double
    Dim cSun As New clsSun
    Dim dblHeightDiff As Double
    
    'Annual parameter reaches maximum in late July and minimum in late January
    dblAnnual = -sinD(cSun.MeanSun(dblDate + dblTime) - 30) / 2
    'Daily paramter reaches maximum at 2pm mean solar time and minimum at 2am
    dblDaily = -cosD(dblTime * 360 + udtLocation.dblLongitude - 30) / 2
    Select Case cboBasis.ListIndex
        Case Manual
            With udtWeather.udtClimate
                udtWeatherNow.dblHumidity = .udtHumidity.dblMean + dblAnnual * .udtHumidity.dblAnnualRange + dblDaily * .udtHumidity.dblDailyRange
                udtWeatherNow.dblPressure = .udtPressure.dblMean + dblAnnual * .udtPressure.dblAnnualRange + dblDaily * .udtPressure.dblDailyRange
                udtWeatherNow.dblTemperature = .udtTemperature.dblMean + dblAnnual * .udtTemperature.dblAnnualRange + dblDaily * .udtTemperature.dblDailyRange
            End With
        Case GlobalW
            udtWeatherNow.dblHumidity = 50
            udtWeatherNow.dblPressure = 1010 + 10 * sinD(2 * udtPosition.dblLatitude)
            If udtPosition.dblLatitude < -45 Then
                udtWeatherNow.dblPressure = udtWeatherNow.dblPressure + (udtPosition.dblLatitude + 45) / 3
            End If
            udtWeatherNow.dblPressure = udtWeatherNow.dblPressure / Exp(udtPosition.dblHeight / 7143)
            udtWeatherNow.dblTemperature = 27 - Abs(udtPosition.dblLatitude) * 0.467 - udtPosition.dblHeight * 0.005688 + 50 * sinD(udtLocation.dblLatitude) * dblAnnual + 2 * dblDaily
        Case LocalW
            dblMinDistance = 1000000 'Impossibly large
            For intCountry = 0 To udtLocationData.intNStatesCountries - 1
                For intCity = 0 To udtLocationData.udtCountryState(intCountry).intNCities - 1
                    For intNeighborhood = 0 To udtLocationData.udtCountryState(intCountry).udtCity(intCity).intNNeighborhoods - 1
                        With udtLocationData.udtCountryState(intCountry).udtCity(intCity).udtNeighborhood(intNeighborhood).udtPosition
                            dblDistance = sinD(.dblLatitude) * sinD(udtPosition.dblLatitude) + cosD(.dblLatitude) * cosD(udtPosition.dblLatitude) * cosD(.dblLongitude - udtPosition.dblLongitude)
                            If dblDistance > 0.999995 Then
                                dblDistance = 117.48 * Sqr(Square(udtPosition.dblLongitude - .dblLongitude) * cosD((.dblLatitude + udtPosition.dblLatitude) / 2) + Square(.dblLatitude - udtPosition.dblLatitude))
                            ElseIf dblDistance <= -1 Then
                                dblDistance = 20015.19
                            Else
                                dblDistance = 117.48 * acosD(dblDistance)
                            End If
                            dblHeightDiff = udtPosition.dblHeight - .dblHeight
                        End With
                        If dblDistance < dblMinDistance Then
                            dblMinDistance = dblDistance
                            With udtLocationData.udtCountryState(intCountry).udtCity(intCity).udtNeighborhood(intNeighborhood).udtLocalClimate
                                udtWeatherNow.dblHumidity = .udtHumidity.dblMean - .udtHumidity.dblAnnualRange * dblAnnual + .udtHumidity.dblDailyRange * dblDaily
                                udtWeatherNow.dblPressure = (.udtPressure.dblMean - .udtPressure.dblAnnualRange * dblAnnual + .udtPressure.dblDailyRange * dblDaily) / Exp(dblHeightDiff / 7143)
                                udtWeatherNow.dblTemperature = .udtTemperature.dblMean - dblHeightDiff * 0.005688 - .udtTemperature.dblAnnualRange * dblAnnual + .udtTemperature.dblDailyRange * dblDaily
                            End With
                        End If
                    Next
                Next
            Next
        Case Else
            MsgBox ("Invalid Weather Basis.")
    End Select
End Sub
Public Function WriteWeather() As String
'Determine and print the current weather
    WriteWeather = "Basis "
    Select Case udtWeather.udtBasis
        Case GlobalW
            WriteWeather = WriteWeather & "Global "
        Case LocalW
            WriteWeather = WriteWeather & "Local "
        Case Manual
            WriteWeather = WriteWeather & "Manual "
    End Select
    WriteWeather = WriteWeather & "T " & Format(udtWeatherNow.dblTemperature, "###.0") & " C, "
    WriteWeather = WriteWeather & "P " & Format(udtWeatherNow.dblPressure, "####") & " mbar, "
    WriteWeather = WriteWeather & "RH " & Format(udtWeatherNow.dblHumidity, "###") & " %"
End Function
Private Sub cboBasis_Click()
'Update the form with change of basis
    Dim blnManual As Boolean
    
    blnManual = (cboBasis.ListIndex = Manual)
    txtTM.Enabled = blnManual
    txtTD.Enabled = blnManual
    txtTA.Enabled = blnManual
    txtPM.Enabled = blnManual
    txtPD.Enabled = blnManual
    txtPA.Enabled = blnManual
    txtHM.Enabled = blnManual
    txtHD.Enabled = blnManual
    txtHA.Enabled = blnManual
End Sub

Private Sub cmdCancel_Click()
    blnCancelled = True
    Unload Me
End Sub

Private Sub cmdOK_Click()
    Dim blnError As Boolean
    Dim blnLocalError As Boolean
    Dim strError As String
    
    blnError = False
    strError = "Invalid weather parameters"
    blnLocalError = False
    If cboBasis.ListIndex = Manual Then
        'Load parameters
        If Not IsNumeric(txtTM) Then
            strError = strError & vbCrLf & "Mean temperature must be a number"
            blnLocalError = True
        ElseIf txtTM < TMin Or txtTM > TMax Then
            strError = "Mean temperature out of range"
            blnLocalError = True
        End If
        If Not IsNumeric(txtTD) Then
            strError = strError & vbCrLf & "Daily temperature range must be a number"
            blnLocalError = True
        ElseIf txtTD < 0 Or txtTD > TMax - TMin Then
            strError = "Daily temperature range out of range"
            blnLocalError = True
        End If
        If Not IsNumeric(txtTA) Then
            strError = strError & vbCrLf & "Annual temperature range must be a number"
            blnLocalError = True
        ElseIf txtTA < 0 Or txtTA > TMax - TMin Then
            strError = "Annual temperature range out of range"
            blnLocalError = True
        End If
        If Not blnLocalError Then
            If txtTM + (CDbl(txtTD) + txtTD) / 2 > TMax Or txtTM - (CDbl(txtTD) + txtTA) / 2 < TMin Then
                strError = "Temperature exceeds acceptable range some of the time"
                blnLocalError = True
            End If
        End If
        If blnLocalError Then blnError = True
        blnLocalError = False
        If Not IsNumeric(txtPM) Then
            strError = strError & vbCrLf & "Mean pressure must be a number"
            blnLocalError = True
        ElseIf txtPM < PMin Or txtPM > PMax Then
            strError = "Mean pressure out of range"
            blnLocalError = True
        End If
        If Not IsNumeric(txtPD) Then
            strError = strError & vbCrLf & "Daily pressure range must be a number"
            blnLocalError = True
        ElseIf txtPD < 0 Or txtPD > PMax - PMin Then
            strError = "Daily pressure range out of range"
            blnLocalError = True
        End If
        If Not IsNumeric(txtPA) Then
            strError = strError & vbCrLf & "Annual pressure range must be a number"
            blnLocalError = True
        ElseIf txtPA < 0 Or txtPA > PMax - PMin Then
            strError = "Annual pressure range out of range"
            blnLocalError = True
        End If
        If Not blnLocalError Then
            If txtPM + (CDbl(txtPD) + txtPD) / 2 > PMax Or txtPM - (CDbl(txtPD) + txtPA) / 2 < PMin Then
                strError = "Pressure exceeds acceptable range some of the time"
                blnLocalError = True
            End If
        End If
        If blnLocalError Then blnError = True
        blnLocalError = False
        If Not IsNumeric(txtHM) Then
            strError = strError & vbCrLf & "Mean humidity must be a number"
            blnLocalError = True
        ElseIf txtHM < HMin Or txtHM > HMax Then
            strError = "Mean humidity out of range"
            blnLocalError = True
        End If
        If Not IsNumeric(txtHD) Then
            strError = strError & vbCrLf & "Daily humidity range must be a number"
            blnLocalError = True
        ElseIf txtHD < 0 Or txtHD > HMax - HMin Then
            strError = "Daily humidity range out of range"
            blnLocalError = True
        End If
        If Not IsNumeric(txtHA) Then
            strError = strError & vbCrLf & "Annual humidity range must be a number"
            blnLocalError = True
        ElseIf txtHA < 0 Or txtHA > HMax - HMin Then
            strError = "Annual humidity range out of range"
            blnLocalError = True
        End If
        If Not blnLocalError Then
            If txtHM + (CDbl(txtHD) + txtHA) / 2 > HMax Or txtHM - (CDbl(txtHD) + txtHA) / 2 < HMin Then
                strError = "Humidity exceeds acceptable range some of the time"
                blnLocalError = True
            End If
        End If
        If blnLocalError Then blnError = True
        If blnError Then
            MsgBox (strError)
        Else
            udtWeather.udtBasis = cboBasis.ListIndex
            With udtWeather.udtClimate
                .udtHumidity.dblAnnualRange = txtHA
                .udtHumidity.dblDailyRange = txtHD
                .udtHumidity.dblMean = txtHM
                .udtPressure.dblAnnualRange = txtPA
                .udtPressure.dblDailyRange = txtPD
                .udtPressure.dblMean = txtPM
                .udtTemperature.dblAnnualRange = txtTA
                .udtTemperature.dblDailyRange = txtTD
                .udtTemperature.dblMean = txtTM
            End With
            Unload Me
        End If
    Else
        udtWeather.udtBasis = cboBasis.ListIndex
        Unload Me
    End If
End Sub

Private Sub Form_Load()
    cboBasis.Clear
    cboBasis.AddItem ("Global")
    cboBasis.AddItem ("Local")
    cboBasis.AddItem ("Manual")
    cboBasis.Text = "Local"
    cboBasis.ListIndex = udtWeather.udtBasis
    Select Case udtWeather.udtBasis
        Case 0:
            cboBasis.Text = "Global"
        Case 1:
            cboBasis.Text = "Local"
        Case 2:
            cboBasis.Text = "Manual"
    End Select
    cboBasis_Click
    With udtWeather.udtClimate
        txtTM = .udtTemperature.dblMean
        txtTD = .udtTemperature.dblDailyRange
        txtTA = .udtTemperature.dblAnnualRange
        txtPM = .udtPressure.dblMean
        txtPD = .udtPressure.dblDailyRange
        txtPA = .udtPressure.dblAnnualRange
        txtHM = .udtHumidity.dblMean
        txtHD = .udtHumidity.dblDailyRange
        txtHA = .udtHumidity.dblAnnualRange
    End With
    blnCancelled = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If Not blnCancelled Then Call cmdOK_Click
End Sub
